/*----- PROTECTED REGION ID(GigeVCamStateMachine.cpp) ENABLED START -----*/
//=============================================================================
//
// file :        GigeVCamStateMachine.cpp
//
// description : C++ source for the �name� and its alowed
//               methods for commands and attributes
//
// project :     Gigabit Camera Server.
//
// $Author: giulio $
//
// $Revision: 1.22 $
// $Date: 2018-10-03 13:55:16 $
//
// SVN only:
// $HeadURL:  $
//
// CVS only:
// $Source: /home/cvsadm/cvsroot/fermi/servers/gigevcam/src/GigeVCamStateMachine.cpp,v $
// $Log: GigeVCamStateMachine.cpp,v $
// Revision 1.22  2018-10-03 13:55:16  giulio
// Allowing set scale/offset when ccd is off, bugfixing
//
// Revision 1.21  2017-04-19 07:00:53  giulio
// Fixed feedback mode
//
// Revision 1.20  2017-03-20 12:22:22  giulio
// Added aCA2000-50gm, added support for tango based trajectory feedback
//
// Revision 1.19  2014-12-30 08:33:57  giulio
// Added Model attribute
//
// Revision 1.18  2014-08-28 07:49:45  giulio
// Added imagesum attribute and scA1400 ccd
//
// Revision 1.17  2013-08-07 08:00:26  giulio
// Added mutexes in get_data commands; moved to Tango8; changed shutdown timeouts
//
// Revision 1.16  2013-05-29 12:49:17  giulio
// Implemented hwroiparam
//
// Revision 1.15  2013-05-17 13:14:08  giulio
// Added disable trigger timeout, stream grabber configurable
//
// Revision 1.14  2013-04-11 14:29:53  giulio
// Added digital image stabilization, saved roi_threshold
//
// Revision 1.13  2013-02-08 15:12:34  giulio
// Added autoreconnect disable + avA1000 ccd
//
// Revision 1.12  2013-01-24 08:47:29  giulio
// Added binning
//
// Revision 1.11  2012-09-17 11:44:53  giulio
// Major updates (hw roi, auto gain/exposure, rnm..)
//
// Revision 1.10  2012-07-02 16:06:11  giulio
// Added saveparam command
//
// Revision 1.9  2012-01-30 12:47:01  giulio
// Added attributes for image transfer optimization
//
// Revision 1.8  2011-12-28 08:00:53  giulio
// Extended exposure timeout to its maximu value. Store all ccd parameters through SaveScale command
//
// Revision 1.7  2011/06/14 12:19:08  giulio
// Fixed GetImag16 bug
//
// Revision 1.6  2011/05/13 09:44:00  giulio
// Fixed some bugs, moved to tango7, supported Pylon 2.3.3
//
//
//=============================================================================
//                This file is generated by POGO
//        (Program Obviously used to Generate tango Object)
//=============================================================================



#include <GigeVCam.h>
#include <GigeVCamClass.h>

/*----- PROTECTED REGION END -----*/	//	GigeVCam::GigeVCamStateMachine.cpp

//================================================================
//  States  |  Description
//================================================================
//  ON      |  The server is up anc connected to a camera
//  OFF     |  the server is up but it isn't connected to any camera
//  FAULT   |  A camera doesn't respond or the external trigger is missing (if the camera is configured with external trigger).
//  ALARM   |  When communication become unreliable.


namespace GigeVCam_ns
{
//=================================================
//		Attributes Allowed Methods
//=================================================

//--------------------------------------------------------
/**
 *	Method      : GigeVCam::is_HorPos_allowed()
 *	Description : Execution allowed for HorPos attribute
 */
//--------------------------------------------------------
bool GigeVCam::is_HorPos_allowed(TANGO_UNUSED(Tango::AttReqType type))
{

	//	Check access type.
	if ( type==Tango::READ_REQ )
	{
		//	Compare device state with not allowed states for READ 
		if (get_state()==Tango::OFF ||
			get_state()==Tango::FAULT)
		{
		/*----- PROTECTED REGION ID(GigeVCam::HorPosStateAllowed_READ) ENABLED START -----*/
		
		/*----- PROTECTED REGION END -----*/	//	GigeVCam::HorPosStateAllowed_READ
			return false;
		}
		return true;
	}
	return true;
}

//--------------------------------------------------------
/**
 *	Method      : GigeVCam::is_VerPos_allowed()
 *	Description : Execution allowed for VerPos attribute
 */
//--------------------------------------------------------
bool GigeVCam::is_VerPos_allowed(TANGO_UNUSED(Tango::AttReqType type))
{

	//	Check access type.
	if ( type==Tango::READ_REQ )
	{
		//	Compare device state with not allowed states for READ 
		if (get_state()==Tango::OFF ||
			get_state()==Tango::FAULT)
		{
		/*----- PROTECTED REGION ID(GigeVCam::VerPosStateAllowed_READ) ENABLED START -----*/
		
		/*----- PROTECTED REGION END -----*/	//	GigeVCam::VerPosStateAllowed_READ
			return false;
		}
		return true;
	}
	return true;
}

//--------------------------------------------------------
/**
 *	Method      : GigeVCam::is_MaxVal_allowed()
 *	Description : Execution allowed for MaxVal attribute
 */
//--------------------------------------------------------
bool GigeVCam::is_MaxVal_allowed(TANGO_UNUSED(Tango::AttReqType type))
{

	//	Check access type.
	if ( type==Tango::READ_REQ )
	{
		//	Compare device state with not allowed states for READ 
		if (get_state()==Tango::OFF ||
			get_state()==Tango::FAULT)
		{
		/*----- PROTECTED REGION ID(GigeVCam::MaxValStateAllowed_READ) ENABLED START -----*/
		
		/*----- PROTECTED REGION END -----*/	//	GigeVCam::MaxValStateAllowed_READ
			return false;
		}
		return true;
	}
	return true;
}

//--------------------------------------------------------
/**
 *	Method      : GigeVCam::is_CountMaxVal_allowed()
 *	Description : Execution allowed for CountMaxVal attribute
 */
//--------------------------------------------------------
bool GigeVCam::is_CountMaxVal_allowed(TANGO_UNUSED(Tango::AttReqType type))
{

	//	Check access type.
	if ( type==Tango::READ_REQ )
	{
		//	Compare device state with not allowed states for READ 
		if (get_state()==Tango::OFF ||
			get_state()==Tango::FAULT)
		{
		/*----- PROTECTED REGION ID(GigeVCam::CountMaxValStateAllowed_READ) ENABLED START -----*/
		
		/*----- PROTECTED REGION END -----*/	//	GigeVCam::CountMaxValStateAllowed_READ
			return false;
		}
		return true;
	}
	return true;
}

//--------------------------------------------------------
/**
 *	Method      : GigeVCam::is_HorSigma_allowed()
 *	Description : Execution allowed for HorSigma attribute
 */
//--------------------------------------------------------
bool GigeVCam::is_HorSigma_allowed(TANGO_UNUSED(Tango::AttReqType type))
{

	//	Check access type.
	if ( type==Tango::READ_REQ )
	{
		//	Compare device state with not allowed states for READ 
		if (get_state()==Tango::OFF ||
			get_state()==Tango::FAULT)
		{
		/*----- PROTECTED REGION ID(GigeVCam::HorSigmaStateAllowed_READ) ENABLED START -----*/
		
		/*----- PROTECTED REGION END -----*/	//	GigeVCam::HorSigmaStateAllowed_READ
			return false;
		}
		return true;
	}
	return true;
}

//--------------------------------------------------------
/**
 *	Method      : GigeVCam::is_VerSigma_allowed()
 *	Description : Execution allowed for VerSigma attribute
 */
//--------------------------------------------------------
bool GigeVCam::is_VerSigma_allowed(TANGO_UNUSED(Tango::AttReqType type))
{

	//	Check access type.
	if ( type==Tango::READ_REQ )
	{
		//	Compare device state with not allowed states for READ 
		if (get_state()==Tango::OFF ||
			get_state()==Tango::FAULT)
		{
		/*----- PROTECTED REGION ID(GigeVCam::VerSigmaStateAllowed_READ) ENABLED START -----*/
		
		/*----- PROTECTED REGION END -----*/	//	GigeVCam::VerSigmaStateAllowed_READ
			return false;
		}
		return true;
	}
	return true;
}

//--------------------------------------------------------
/**
 *	Method      : GigeVCam::is_Area_allowed()
 *	Description : Execution allowed for Area attribute
 */
//--------------------------------------------------------
bool GigeVCam::is_Area_allowed(TANGO_UNUSED(Tango::AttReqType type))
{

	//	Check access type.
	if ( type==Tango::READ_REQ )
	{
		//	Compare device state with not allowed states for READ 
		if (get_state()==Tango::OFF ||
			get_state()==Tango::FAULT)
		{
		/*----- PROTECTED REGION ID(GigeVCam::AreaStateAllowed_READ) ENABLED START -----*/
		
		/*----- PROTECTED REGION END -----*/	//	GigeVCam::AreaStateAllowed_READ
			return false;
		}
		return true;
	}
	return true;
}

//--------------------------------------------------------
/**
 *	Method      : GigeVCam::is_HVCovar_allowed()
 *	Description : Execution allowed for HVCovar attribute
 */
//--------------------------------------------------------
bool GigeVCam::is_HVCovar_allowed(TANGO_UNUSED(Tango::AttReqType type))
{

	//	Check access type.
	if ( type==Tango::READ_REQ )
	{
		//	Compare device state with not allowed states for READ 
		if (get_state()==Tango::OFF ||
			get_state()==Tango::FAULT)
		{
		/*----- PROTECTED REGION ID(GigeVCam::HVCovarStateAllowed_READ) ENABLED START -----*/
		
		/*----- PROTECTED REGION END -----*/	//	GigeVCam::HVCovarStateAllowed_READ
			return false;
		}
		return true;
	}
	return true;
}

//--------------------------------------------------------
/**
 *	Method      : GigeVCam::is_CameraCounter_allowed()
 *	Description : Execution allowed for CameraCounter attribute
 */
//--------------------------------------------------------
bool GigeVCam::is_CameraCounter_allowed(TANGO_UNUSED(Tango::AttReqType type))
{

	//	Not any excluded states for CameraCounter attribute in read access.
	/*----- PROTECTED REGION ID(GigeVCam::CameraCounterStateAllowed_READ) ENABLED START -----*/
	
	/*----- PROTECTED REGION END -----*/	//	GigeVCam::CameraCounterStateAllowed_READ
	return true;
}

//--------------------------------------------------------
/**
 *	Method      : GigeVCam::is_AcquisitionCounter_allowed()
 *	Description : Execution allowed for AcquisitionCounter attribute
 */
//--------------------------------------------------------
bool GigeVCam::is_AcquisitionCounter_allowed(TANGO_UNUSED(Tango::AttReqType type))
{

	//	Check access type.
	if ( type==Tango::READ_REQ )
	{
		//	Compare device state with not allowed states for READ 
		if (get_state()==Tango::OFF ||
			get_state()==Tango::FAULT)
		{
		/*----- PROTECTED REGION ID(GigeVCam::AcquisitionCounterStateAllowed_READ) ENABLED START -----*/
		
		/*----- PROTECTED REGION END -----*/	//	GigeVCam::AcquisitionCounterStateAllowed_READ
			return false;
		}
		return true;
	}
	return true;
}

//--------------------------------------------------------
/**
 *	Method      : GigeVCam::is_Height_allowed()
 *	Description : Execution allowed for Height attribute
 */
//--------------------------------------------------------
bool GigeVCam::is_Height_allowed(TANGO_UNUSED(Tango::AttReqType type))
{

	//	Check access type.
	if ( type==Tango::READ_REQ )
	{
		//	Compare device state with not allowed states for READ 
		if (get_state()==Tango::OFF ||
			get_state()==Tango::FAULT)
		{
		/*----- PROTECTED REGION ID(GigeVCam::HeightStateAllowed_READ) ENABLED START -----*/
		
		/*----- PROTECTED REGION END -----*/	//	GigeVCam::HeightStateAllowed_READ
			return false;
		}
		return true;
	}
	return true;
}

//--------------------------------------------------------
/**
 *	Method      : GigeVCam::is_Width_allowed()
 *	Description : Execution allowed for Width attribute
 */
//--------------------------------------------------------
bool GigeVCam::is_Width_allowed(TANGO_UNUSED(Tango::AttReqType type))
{

	//	Check access type.
	if ( type==Tango::READ_REQ )
	{
		//	Compare device state with not allowed states for READ 
		if (get_state()==Tango::OFF ||
			get_state()==Tango::FAULT)
		{
		/*----- PROTECTED REGION ID(GigeVCam::WidthStateAllowed_READ) ENABLED START -----*/
		
		/*----- PROTECTED REGION END -----*/	//	GigeVCam::WidthStateAllowed_READ
			return false;
		}
		return true;
	}
	return true;
}

//--------------------------------------------------------
/**
 *	Method      : GigeVCam::is_ProcessingTime_allowed()
 *	Description : Execution allowed for ProcessingTime attribute
 */
//--------------------------------------------------------
bool GigeVCam::is_ProcessingTime_allowed(TANGO_UNUSED(Tango::AttReqType type))
{

	//	Check access type.
	if ( type==Tango::READ_REQ )
	{
		//	Compare device state with not allowed states for READ 
		if (get_state()==Tango::OFF ||
			get_state()==Tango::FAULT)
		{
		/*----- PROTECTED REGION ID(GigeVCam::ProcessingTimeStateAllowed_READ) ENABLED START -----*/
		
		/*----- PROTECTED REGION END -----*/	//	GigeVCam::ProcessingTimeStateAllowed_READ
			return false;
		}
		return true;
	}
	return true;
}

//--------------------------------------------------------
/**
 *	Method      : GigeVCam::is_Frequency_allowed()
 *	Description : Execution allowed for Frequency attribute
 */
//--------------------------------------------------------
bool GigeVCam::is_Frequency_allowed(TANGO_UNUSED(Tango::AttReqType type))
{

	//	Check access type.
	if ( type==Tango::READ_REQ )
	{
		//	Compare device state with not allowed states for READ 
		if (get_state()==Tango::OFF ||
			get_state()==Tango::FAULT)
		{
		/*----- PROTECTED REGION ID(GigeVCam::FrequencyStateAllowed_READ) ENABLED START -----*/
		
		/*----- PROTECTED REGION END -----*/	//	GigeVCam::FrequencyStateAllowed_READ
			return false;
		}
		return true;
	}
	return true;
}

//--------------------------------------------------------
/**
 *	Method      : GigeVCam::is_Trigger_allowed()
 *	Description : Execution allowed for Trigger attribute
 */
//--------------------------------------------------------
bool GigeVCam::is_Trigger_allowed(TANGO_UNUSED(Tango::AttReqType type))
{
	//	Not any excluded states for Trigger attribute in Write access.
	/*----- PROTECTED REGION ID(GigeVCam::TriggerStateAllowed_WRITE) ENABLED START -----*/

	/*----- PROTECTED REGION END -----*/	//	GigeVCam::TriggerStateAllowed_WRITE

	//	Not any excluded states for Trigger attribute in read access.
	/*----- PROTECTED REGION ID(GigeVCam::TriggerStateAllowed_READ) ENABLED START -----*/
	
	/*----- PROTECTED REGION END -----*/	//	GigeVCam::TriggerStateAllowed_READ
	return true;
}

//--------------------------------------------------------
/**
 *	Method      : GigeVCam::is_Exposure_allowed()
 *	Description : Execution allowed for Exposure attribute
 */
//--------------------------------------------------------
bool GigeVCam::is_Exposure_allowed(TANGO_UNUSED(Tango::AttReqType type))
{
	//	Not any excluded states for Exposure attribute in Write access.
	/*----- PROTECTED REGION ID(GigeVCam::ExposureStateAllowed_WRITE) ENABLED START -----*/

	/*----- PROTECTED REGION END -----*/	//	GigeVCam::ExposureStateAllowed_WRITE

	//	Not any excluded states for Exposure attribute in read access.
	/*----- PROTECTED REGION ID(GigeVCam::ExposureStateAllowed_READ) ENABLED START -----*/
	
	/*----- PROTECTED REGION END -----*/	//	GigeVCam::ExposureStateAllowed_READ
	return true;
}

//--------------------------------------------------------
/**
 *	Method      : GigeVCam::is_Gain_allowed()
 *	Description : Execution allowed for Gain attribute
 */
//--------------------------------------------------------
bool GigeVCam::is_Gain_allowed(TANGO_UNUSED(Tango::AttReqType type))
{
	//	Not any excluded states for Gain attribute in Write access.
	/*----- PROTECTED REGION ID(GigeVCam::GainStateAllowed_WRITE) ENABLED START -----*/

	/*----- PROTECTED REGION END -----*/	//	GigeVCam::GainStateAllowed_WRITE

	//	Not any excluded states for Gain attribute in read access.
	/*----- PROTECTED REGION ID(GigeVCam::GainStateAllowed_READ) ENABLED START -----*/
	
	/*----- PROTECTED REGION END -----*/	//	GigeVCam::GainStateAllowed_READ
	return true;
}

//--------------------------------------------------------
/**
 *	Method      : GigeVCam::is_RoiThreshold_allowed()
 *	Description : Execution allowed for RoiThreshold attribute
 */
//--------------------------------------------------------
bool GigeVCam::is_RoiThreshold_allowed(TANGO_UNUSED(Tango::AttReqType type))
{
	//	Not any excluded states for RoiThreshold attribute in Write access.
	/*----- PROTECTED REGION ID(GigeVCam::RoiThresholdStateAllowed_WRITE) ENABLED START -----*/

	/*----- PROTECTED REGION END -----*/	//	GigeVCam::RoiThresholdStateAllowed_WRITE

	//	Not any excluded states for RoiThreshold attribute in read access.
	/*----- PROTECTED REGION ID(GigeVCam::RoiThresholdStateAllowed_READ) ENABLED START -----*/
	
	/*----- PROTECTED REGION END -----*/	//	GigeVCam::RoiThresholdStateAllowed_READ
	return true;
}

//--------------------------------------------------------
/**
 *	Method      : GigeVCam::is_AutoRoi_allowed()
 *	Description : Execution allowed for AutoRoi attribute
 */
//--------------------------------------------------------
bool GigeVCam::is_AutoRoi_allowed(TANGO_UNUSED(Tango::AttReqType type))
{
	//	Not any excluded states for AutoRoi attribute in Write access.
	/*----- PROTECTED REGION ID(GigeVCam::AutoRoiStateAllowed_WRITE) ENABLED START -----*/

	/*----- PROTECTED REGION END -----*/	//	GigeVCam::AutoRoiStateAllowed_WRITE

	//	Check access type.
	if ( type==Tango::READ_REQ )
	{
		//	Compare device state with not allowed states for READ 
		if (get_state()==Tango::OFF ||
			get_state()==Tango::FAULT)
		{
		/*----- PROTECTED REGION ID(GigeVCam::AutoRoiStateAllowed_READ) ENABLED START -----*/
		
		/*----- PROTECTED REGION END -----*/	//	GigeVCam::AutoRoiStateAllowed_READ
			return false;
		}
		return true;
	}
	return true;
}

//--------------------------------------------------------
/**
 *	Method      : GigeVCam::is_SwRoi_allowed()
 *	Description : Execution allowed for SwRoi attribute
 */
//--------------------------------------------------------
bool GigeVCam::is_SwRoi_allowed(TANGO_UNUSED(Tango::AttReqType type))
{
	//	Not any excluded states for SwRoi attribute in Write access.
	/*----- PROTECTED REGION ID(GigeVCam::SwRoiStateAllowed_WRITE) ENABLED START -----*/

	/*----- PROTECTED REGION END -----*/	//	GigeVCam::SwRoiStateAllowed_WRITE

	//	Check access type.
	if ( type==Tango::READ_REQ )
	{
		//	Compare device state with not allowed states for READ 
		if (get_state()==Tango::OFF ||
			get_state()==Tango::FAULT)
		{
		/*----- PROTECTED REGION ID(GigeVCam::SwRoiStateAllowed_READ) ENABLED START -----*/
		
		/*----- PROTECTED REGION END -----*/	//	GigeVCam::SwRoiStateAllowed_READ
			return false;
		}
		return true;
	}
	return true;
}

//--------------------------------------------------------
/**
 *	Method      : GigeVCam::is_HwRoi_allowed()
 *	Description : Execution allowed for HwRoi attribute
 */
//--------------------------------------------------------
bool GigeVCam::is_HwRoi_allowed(TANGO_UNUSED(Tango::AttReqType type))
{
	//	Not any excluded states for HwRoi attribute in Write access.
	/*----- PROTECTED REGION ID(GigeVCam::HwRoiStateAllowed_WRITE) ENABLED START -----*/

	/*----- PROTECTED REGION END -----*/	//	GigeVCam::HwRoiStateAllowed_WRITE

	//	Check access type.
	if ( type==Tango::READ_REQ )
	{
		//	Compare device state with not allowed states for READ 
		if (get_state()==Tango::OFF ||
			get_state()==Tango::FAULT)
		{
		/*----- PROTECTED REGION ID(GigeVCam::HwRoiStateAllowed_READ) ENABLED START -----*/
		
		/*----- PROTECTED REGION END -----*/	//	GigeVCam::HwRoiStateAllowed_READ
			return false;
		}
		return true;
	}
	return true;
}

//--------------------------------------------------------
/**
 *	Method      : GigeVCam::is_PlotMode_allowed()
 *	Description : Execution allowed for PlotMode attribute
 */
//--------------------------------------------------------
bool GigeVCam::is_PlotMode_allowed(TANGO_UNUSED(Tango::AttReqType type))
{
	//	Not any excluded states for PlotMode attribute in Write access.
	/*----- PROTECTED REGION ID(GigeVCam::PlotModeStateAllowed_WRITE) ENABLED START -----*/

	/*----- PROTECTED REGION END -----*/	//	GigeVCam::PlotModeStateAllowed_WRITE

	//	Not any excluded states for PlotMode attribute in read access.
	/*----- PROTECTED REGION ID(GigeVCam::PlotModeStateAllowed_READ) ENABLED START -----*/
	
	/*----- PROTECTED REGION END -----*/	//	GigeVCam::PlotModeStateAllowed_READ
	return true;
}

//--------------------------------------------------------
/**
 *	Method      : GigeVCam::is_IconSize_allowed()
 *	Description : Execution allowed for IconSize attribute
 */
//--------------------------------------------------------
bool GigeVCam::is_IconSize_allowed(TANGO_UNUSED(Tango::AttReqType type))
{
	//	Not any excluded states for IconSize attribute in Write access.
	/*----- PROTECTED REGION ID(GigeVCam::IconSizeStateAllowed_WRITE) ENABLED START -----*/

	/*----- PROTECTED REGION END -----*/	//	GigeVCam::IconSizeStateAllowed_WRITE

	//	Check access type.
	if ( type==Tango::READ_REQ )
	{
		//	Compare device state with not allowed states for READ 
		if (get_state()==Tango::OFF ||
			get_state()==Tango::FAULT)
		{
		/*----- PROTECTED REGION ID(GigeVCam::IconSizeStateAllowed_READ) ENABLED START -----*/
		
		/*----- PROTECTED REGION END -----*/	//	GigeVCam::IconSizeStateAllowed_READ
			return false;
		}
		return true;
	}
	return true;
}

//--------------------------------------------------------
/**
 *	Method      : GigeVCam::is_LowPassOrder_allowed()
 *	Description : Execution allowed for LowPassOrder attribute
 */
//--------------------------------------------------------
bool GigeVCam::is_LowPassOrder_allowed(TANGO_UNUSED(Tango::AttReqType type))
{
	//	Not any excluded states for LowPassOrder attribute in Write access.
	/*----- PROTECTED REGION ID(GigeVCam::LowPassOrderStateAllowed_WRITE) ENABLED START -----*/

	/*----- PROTECTED REGION END -----*/	//	GigeVCam::LowPassOrderStateAllowed_WRITE

	//	Check access type.
	if ( type==Tango::READ_REQ )
	{
		//	Compare device state with not allowed states for READ 
		if (get_state()==Tango::OFF ||
			get_state()==Tango::FAULT)
		{
		/*----- PROTECTED REGION ID(GigeVCam::LowPassOrderStateAllowed_READ) ENABLED START -----*/
		
		/*----- PROTECTED REGION END -----*/	//	GigeVCam::LowPassOrderStateAllowed_READ
			return false;
		}
		return true;
	}
	return true;
}

//--------------------------------------------------------
/**
 *	Method      : GigeVCam::is_Rotation_allowed()
 *	Description : Execution allowed for Rotation attribute
 */
//--------------------------------------------------------
bool GigeVCam::is_Rotation_allowed(TANGO_UNUSED(Tango::AttReqType type))
{
	//	Not any excluded states for Rotation attribute in Write access.
	/*----- PROTECTED REGION ID(GigeVCam::RotationStateAllowed_WRITE) ENABLED START -----*/

	/*----- PROTECTED REGION END -----*/	//	GigeVCam::RotationStateAllowed_WRITE

	//	Check access type.
	if ( type==Tango::READ_REQ )
	{
		//	Compare device state with not allowed states for READ 
		if (get_state()==Tango::OFF ||
			get_state()==Tango::FAULT)
		{
		/*----- PROTECTED REGION ID(GigeVCam::RotationStateAllowed_READ) ENABLED START -----*/
		
		/*----- PROTECTED REGION END -----*/	//	GigeVCam::RotationStateAllowed_READ
			return false;
		}
		return true;
	}
	return true;
}

//--------------------------------------------------------
/**
 *	Method      : GigeVCam::is_Mirror_allowed()
 *	Description : Execution allowed for Mirror attribute
 */
//--------------------------------------------------------
bool GigeVCam::is_Mirror_allowed(TANGO_UNUSED(Tango::AttReqType type))
{
	//	Not any excluded states for Mirror attribute in Write access.
	/*----- PROTECTED REGION ID(GigeVCam::MirrorStateAllowed_WRITE) ENABLED START -----*/

	/*----- PROTECTED REGION END -----*/	//	GigeVCam::MirrorStateAllowed_WRITE

	//	Check access type.
	if ( type==Tango::READ_REQ )
	{
		//	Compare device state with not allowed states for READ 
		if (get_state()==Tango::OFF ||
			get_state()==Tango::FAULT)
		{
		/*----- PROTECTED REGION ID(GigeVCam::MirrorStateAllowed_READ) ENABLED START -----*/
		
		/*----- PROTECTED REGION END -----*/	//	GigeVCam::MirrorStateAllowed_READ
			return false;
		}
		return true;
	}
	return true;
}

//--------------------------------------------------------
/**
 *	Method      : GigeVCam::is_ImageDepth_allowed()
 *	Description : Execution allowed for ImageDepth attribute
 */
//--------------------------------------------------------
bool GigeVCam::is_ImageDepth_allowed(TANGO_UNUSED(Tango::AttReqType type))
{
	//	Not any excluded states for ImageDepth attribute in Write access.
	/*----- PROTECTED REGION ID(GigeVCam::ImageDepthStateAllowed_WRITE) ENABLED START -----*/

	/*----- PROTECTED REGION END -----*/	//	GigeVCam::ImageDepthStateAllowed_WRITE

	//	Not any excluded states for ImageDepth attribute in read access.
	/*----- PROTECTED REGION ID(GigeVCam::ImageDepthStateAllowed_READ) ENABLED START -----*/
	
	/*----- PROTECTED REGION END -----*/	//	GigeVCam::ImageDepthStateAllowed_READ
	return true;
}

//--------------------------------------------------------
/**
 *	Method      : GigeVCam::is_BackgroundSubtraction_allowed()
 *	Description : Execution allowed for BackgroundSubtraction attribute
 */
//--------------------------------------------------------
bool GigeVCam::is_BackgroundSubtraction_allowed(TANGO_UNUSED(Tango::AttReqType type))
{
	//	Not any excluded states for BackgroundSubtraction attribute in Write access.
	/*----- PROTECTED REGION ID(GigeVCam::BackgroundSubtractionStateAllowed_WRITE) ENABLED START -----*/

	/*----- PROTECTED REGION END -----*/	//	GigeVCam::BackgroundSubtractionStateAllowed_WRITE

	//	Check access type.
	if ( type==Tango::READ_REQ )
	{
		//	Compare device state with not allowed states for READ 
		if (get_state()==Tango::OFF ||
			get_state()==Tango::FAULT)
		{
		/*----- PROTECTED REGION ID(GigeVCam::BackgroundSubtractionStateAllowed_READ) ENABLED START -----*/
		
		/*----- PROTECTED REGION END -----*/	//	GigeVCam::BackgroundSubtractionStateAllowed_READ
			return false;
		}
		return true;
	}
	return true;
}

//--------------------------------------------------------
/**
 *	Method      : GigeVCam::is_EnableProcessing_allowed()
 *	Description : Execution allowed for EnableProcessing attribute
 */
//--------------------------------------------------------
bool GigeVCam::is_EnableProcessing_allowed(TANGO_UNUSED(Tango::AttReqType type))
{
	//	Not any excluded states for EnableProcessing attribute in Write access.
	/*----- PROTECTED REGION ID(GigeVCam::EnableProcessingStateAllowed_WRITE) ENABLED START -----*/

	/*----- PROTECTED REGION END -----*/	//	GigeVCam::EnableProcessingStateAllowed_WRITE

	//	Check access type.
	if ( type==Tango::READ_REQ )
	{
		//	Compare device state with not allowed states for READ 
		if (get_state()==Tango::OFF ||
			get_state()==Tango::FAULT)
		{
		/*----- PROTECTED REGION ID(GigeVCam::EnableProcessingStateAllowed_READ) ENABLED START -----*/
		
		/*----- PROTECTED REGION END -----*/	//	GigeVCam::EnableProcessingStateAllowed_READ
			return false;
		}
		return true;
	}
	return true;
}

//--------------------------------------------------------
/**
 *	Method      : GigeVCam::is_FastProcessing_allowed()
 *	Description : Execution allowed for FastProcessing attribute
 */
//--------------------------------------------------------
bool GigeVCam::is_FastProcessing_allowed(TANGO_UNUSED(Tango::AttReqType type))
{
	//	Not any excluded states for FastProcessing attribute in Write access.
	/*----- PROTECTED REGION ID(GigeVCam::FastProcessingStateAllowed_WRITE) ENABLED START -----*/

	/*----- PROTECTED REGION END -----*/	//	GigeVCam::FastProcessingStateAllowed_WRITE

	//	Check access type.
	if ( type==Tango::READ_REQ )
	{
		//	Compare device state with not allowed states for READ 
		if (get_state()==Tango::OFF ||
			get_state()==Tango::FAULT)
		{
		/*----- PROTECTED REGION ID(GigeVCam::FastProcessingStateAllowed_READ) ENABLED START -----*/
		
		/*----- PROTECTED REGION END -----*/	//	GigeVCam::FastProcessingStateAllowed_READ
			return false;
		}
		return true;
	}
	return true;
}

//--------------------------------------------------------
/**
 *	Method      : GigeVCam::is_Saturation_allowed()
 *	Description : Execution allowed for Saturation attribute
 */
//--------------------------------------------------------
bool GigeVCam::is_Saturation_allowed(TANGO_UNUSED(Tango::AttReqType type))
{

	//	Check access type.
	if ( type==Tango::READ_REQ )
	{
		//	Compare device state with not allowed states for READ 
		if (get_state()==Tango::OFF ||
			get_state()==Tango::FAULT)
		{
		/*----- PROTECTED REGION ID(GigeVCam::SaturationStateAllowed_READ) ENABLED START -----*/
		
		/*----- PROTECTED REGION END -----*/	//	GigeVCam::SaturationStateAllowed_READ
			return false;
		}
		return true;
	}
	return true;
}

//--------------------------------------------------------
/**
 *	Method      : GigeVCam::is_PlotLevel_allowed()
 *	Description : Execution allowed for PlotLevel attribute
 */
//--------------------------------------------------------
bool GigeVCam::is_PlotLevel_allowed(TANGO_UNUSED(Tango::AttReqType type))
{
	//	Not any excluded states for PlotLevel attribute in Write access.
	/*----- PROTECTED REGION ID(GigeVCam::PlotLevelStateAllowed_WRITE) ENABLED START -----*/

	/*----- PROTECTED REGION END -----*/	//	GigeVCam::PlotLevelStateAllowed_WRITE

	//	Not any excluded states for PlotLevel attribute in read access.
	/*----- PROTECTED REGION ID(GigeVCam::PlotLevelStateAllowed_READ) ENABLED START -----*/
	
	/*----- PROTECTED REGION END -----*/	//	GigeVCam::PlotLevelStateAllowed_READ
	return true;
}

//--------------------------------------------------------
/**
 *	Method      : GigeVCam::is_Pause_allowed()
 *	Description : Execution allowed for Pause attribute
 */
//--------------------------------------------------------
bool GigeVCam::is_Pause_allowed(TANGO_UNUSED(Tango::AttReqType type))
{
	//	Not any excluded states for Pause attribute in Write access.
	/*----- PROTECTED REGION ID(GigeVCam::PauseStateAllowed_WRITE) ENABLED START -----*/

	/*----- PROTECTED REGION END -----*/	//	GigeVCam::PauseStateAllowed_WRITE

	//	Not any excluded states for Pause attribute in read access.
	/*----- PROTECTED REGION ID(GigeVCam::PauseStateAllowed_READ) ENABLED START -----*/
	
	/*----- PROTECTED REGION END -----*/	//	GigeVCam::PauseStateAllowed_READ
	return true;
}

//--------------------------------------------------------
/**
 *	Method      : GigeVCam::is_Label_allowed()
 *	Description : Execution allowed for Label attribute
 */
//--------------------------------------------------------
bool GigeVCam::is_Label_allowed(TANGO_UNUSED(Tango::AttReqType type))
{

	//	Not any excluded states for Label attribute in read access.
	/*----- PROTECTED REGION ID(GigeVCam::LabelStateAllowed_READ) ENABLED START -----*/
	
	/*----- PROTECTED REGION END -----*/	//	GigeVCam::LabelStateAllowed_READ
	return true;
}

//--------------------------------------------------------
/**
 *	Method      : GigeVCam::is_HorPosRelative_allowed()
 *	Description : Execution allowed for HorPosRelative attribute
 */
//--------------------------------------------------------
bool GigeVCam::is_HorPosRelative_allowed(TANGO_UNUSED(Tango::AttReqType type))
{

	//	Check access type.
	if ( type==Tango::READ_REQ )
	{
		//	Compare device state with not allowed states for READ 
		if (get_state()==Tango::OFF ||
			get_state()==Tango::FAULT)
		{
		/*----- PROTECTED REGION ID(GigeVCam::HorPosRelativeStateAllowed_READ) ENABLED START -----*/
		
		/*----- PROTECTED REGION END -----*/	//	GigeVCam::HorPosRelativeStateAllowed_READ
			return false;
		}
		return true;
	}
	return true;
}

//--------------------------------------------------------
/**
 *	Method      : GigeVCam::is_VerPosRelative_allowed()
 *	Description : Execution allowed for VerPosRelative attribute
 */
//--------------------------------------------------------
bool GigeVCam::is_VerPosRelative_allowed(TANGO_UNUSED(Tango::AttReqType type))
{

	//	Check access type.
	if ( type==Tango::READ_REQ )
	{
		//	Compare device state with not allowed states for READ 
		if (get_state()==Tango::OFF ||
			get_state()==Tango::FAULT)
		{
		/*----- PROTECTED REGION ID(GigeVCam::VerPosRelativeStateAllowed_READ) ENABLED START -----*/
		
		/*----- PROTECTED REGION END -----*/	//	GigeVCam::VerPosRelativeStateAllowed_READ
			return false;
		}
		return true;
	}
	return true;
}

//--------------------------------------------------------
/**
 *	Method      : GigeVCam::is_Phase_allowed()
 *	Description : Execution allowed for Phase attribute
 */
//--------------------------------------------------------
bool GigeVCam::is_Phase_allowed(TANGO_UNUSED(Tango::AttReqType type))
{

	//	Check access type.
	if ( type==Tango::READ_REQ )
	{
		//	Compare device state with not allowed states for READ 
		if (get_state()==Tango::OFF ||
			get_state()==Tango::FAULT)
		{
		/*----- PROTECTED REGION ID(GigeVCam::PhaseStateAllowed_READ) ENABLED START -----*/
		
		/*----- PROTECTED REGION END -----*/	//	GigeVCam::PhaseStateAllowed_READ
			return false;
		}
		return true;
	}
	return true;
}

//--------------------------------------------------------
/**
 *	Method      : GigeVCam::is_ScaleHor_allowed()
 *	Description : Execution allowed for ScaleHor attribute
 */
//--------------------------------------------------------
bool GigeVCam::is_ScaleHor_allowed(TANGO_UNUSED(Tango::AttReqType type))
{
	//	Not any excluded states for ScaleHor attribute in Write access.
	/*----- PROTECTED REGION ID(GigeVCam::ScaleHorStateAllowed_WRITE) ENABLED START -----*/

	/*----- PROTECTED REGION END -----*/	//	GigeVCam::ScaleHorStateAllowed_WRITE

	//	Not any excluded states for ScaleHor attribute in read access.
	/*----- PROTECTED REGION ID(GigeVCam::ScaleHorStateAllowed_READ) ENABLED START -----*/
		
		/*----- PROTECTED REGION END -----*/	//	GigeVCam::ScaleHorStateAllowed_READ
	return true;
}

//--------------------------------------------------------
/**
 *	Method      : GigeVCam::is_ScaleVer_allowed()
 *	Description : Execution allowed for ScaleVer attribute
 */
//--------------------------------------------------------
bool GigeVCam::is_ScaleVer_allowed(TANGO_UNUSED(Tango::AttReqType type))
{
	//	Not any excluded states for ScaleVer attribute in Write access.
	/*----- PROTECTED REGION ID(GigeVCam::ScaleVerStateAllowed_WRITE) ENABLED START -----*/

	/*----- PROTECTED REGION END -----*/	//	GigeVCam::ScaleVerStateAllowed_WRITE

	//	Not any excluded states for ScaleVer attribute in read access.
	/*----- PROTECTED REGION ID(GigeVCam::ScaleVerStateAllowed_READ) ENABLED START -----*/
		
		/*----- PROTECTED REGION END -----*/	//	GigeVCam::ScaleVerStateAllowed_READ
	return true;
}

//--------------------------------------------------------
/**
 *	Method      : GigeVCam::is_OffsetHor_allowed()
 *	Description : Execution allowed for OffsetHor attribute
 */
//--------------------------------------------------------
bool GigeVCam::is_OffsetHor_allowed(TANGO_UNUSED(Tango::AttReqType type))
{
	//	Not any excluded states for OffsetHor attribute in Write access.
	/*----- PROTECTED REGION ID(GigeVCam::OffsetHorStateAllowed_WRITE) ENABLED START -----*/

	/*----- PROTECTED REGION END -----*/	//	GigeVCam::OffsetHorStateAllowed_WRITE

	//	Not any excluded states for OffsetHor attribute in read access.
	/*----- PROTECTED REGION ID(GigeVCam::OffsetHorStateAllowed_READ) ENABLED START -----*/
	
	/*----- PROTECTED REGION END -----*/	//	GigeVCam::OffsetHorStateAllowed_READ
	return true;
}

//--------------------------------------------------------
/**
 *	Method      : GigeVCam::is_OffsetVer_allowed()
 *	Description : Execution allowed for OffsetVer attribute
 */
//--------------------------------------------------------
bool GigeVCam::is_OffsetVer_allowed(TANGO_UNUSED(Tango::AttReqType type))
{
	//	Not any excluded states for OffsetVer attribute in Write access.
	/*----- PROTECTED REGION ID(GigeVCam::OffsetVerStateAllowed_WRITE) ENABLED START -----*/

	/*----- PROTECTED REGION END -----*/	//	GigeVCam::OffsetVerStateAllowed_WRITE

	//	Not any excluded states for OffsetVer attribute in read access.
	/*----- PROTECTED REGION ID(GigeVCam::OffsetVerStateAllowed_READ) ENABLED START -----*/
	
	/*----- PROTECTED REGION END -----*/	//	GigeVCam::OffsetVerStateAllowed_READ
	return true;
}

//--------------------------------------------------------
/**
 *	Method      : GigeVCam::is_PlotOffsetAxis_allowed()
 *	Description : Execution allowed for PlotOffsetAxis attribute
 */
//--------------------------------------------------------
bool GigeVCam::is_PlotOffsetAxis_allowed(TANGO_UNUSED(Tango::AttReqType type))
{
	//	Not any excluded states for PlotOffsetAxis attribute in Write access.
	/*----- PROTECTED REGION ID(GigeVCam::PlotOffsetAxisStateAllowed_WRITE) ENABLED START -----*/

	/*----- PROTECTED REGION END -----*/	//	GigeVCam::PlotOffsetAxisStateAllowed_WRITE

	//	Not any excluded states for PlotOffsetAxis attribute in read access.
	/*----- PROTECTED REGION ID(GigeVCam::PlotOffsetAxisStateAllowed_READ) ENABLED START -----*/
	
	/*----- PROTECTED REGION END -----*/	//	GigeVCam::PlotOffsetAxisStateAllowed_READ
	return true;
}

//--------------------------------------------------------
/**
 *	Method      : GigeVCam::is_Intensity_allowed()
 *	Description : Execution allowed for Intensity attribute
 */
//--------------------------------------------------------
bool GigeVCam::is_Intensity_allowed(TANGO_UNUSED(Tango::AttReqType type))
{

	//	Check access type.
	if ( type==Tango::READ_REQ )
	{
		//	Compare device state with not allowed states for READ 
		if (get_state()==Tango::OFF ||
			get_state()==Tango::FAULT)
		{
		/*----- PROTECTED REGION ID(GigeVCam::IntensityStateAllowed_READ) ENABLED START -----*/
		
		/*----- PROTECTED REGION END -----*/	//	GigeVCam::IntensityStateAllowed_READ
			return false;
		}
		return true;
	}
	return true;
}

//--------------------------------------------------------
/**
 *	Method      : GigeVCam::is_SignHor_allowed()
 *	Description : Execution allowed for SignHor attribute
 */
//--------------------------------------------------------
bool GigeVCam::is_SignHor_allowed(TANGO_UNUSED(Tango::AttReqType type))
{

	//	Not any excluded states for SignHor attribute in read access.
	/*----- PROTECTED REGION ID(GigeVCam::SignHorStateAllowed_READ) ENABLED START -----*/
	
	/*----- PROTECTED REGION END -----*/	//	GigeVCam::SignHorStateAllowed_READ
	return true;
}

//--------------------------------------------------------
/**
 *	Method      : GigeVCam::is_SignVer_allowed()
 *	Description : Execution allowed for SignVer attribute
 */
//--------------------------------------------------------
bool GigeVCam::is_SignVer_allowed(TANGO_UNUSED(Tango::AttReqType type))
{

	//	Not any excluded states for SignVer attribute in read access.
	/*----- PROTECTED REGION ID(GigeVCam::SignVerStateAllowed_READ) ENABLED START -----*/
	
	/*----- PROTECTED REGION END -----*/	//	GigeVCam::SignVerStateAllowed_READ
	return true;
}

//--------------------------------------------------------
/**
 *	Method      : GigeVCam::is_ProcessMode_allowed()
 *	Description : Execution allowed for ProcessMode attribute
 */
//--------------------------------------------------------
bool GigeVCam::is_ProcessMode_allowed(TANGO_UNUSED(Tango::AttReqType type))
{
	//	Not any excluded states for ProcessMode attribute in Write access.
	/*----- PROTECTED REGION ID(GigeVCam::ProcessModeStateAllowed_WRITE) ENABLED START -----*/

	/*----- PROTECTED REGION END -----*/	//	GigeVCam::ProcessModeStateAllowed_WRITE

	//	Not any excluded states for ProcessMode attribute in read access.
	/*----- PROTECTED REGION ID(GigeVCam::ProcessModeStateAllowed_READ) ENABLED START -----*/
	
	/*----- PROTECTED REGION END -----*/	//	GigeVCam::ProcessModeStateAllowed_READ
	return true;
}

//--------------------------------------------------------
/**
 *	Method      : GigeVCam::is_DebugThread_allowed()
 *	Description : Execution allowed for DebugThread attribute
 */
//--------------------------------------------------------
bool GigeVCam::is_DebugThread_allowed(TANGO_UNUSED(Tango::AttReqType type))
{

	//	Not any excluded states for DebugThread attribute in read access.
	/*----- PROTECTED REGION ID(GigeVCam::DebugThreadStateAllowed_READ) ENABLED START -----*/
	
	/*----- PROTECTED REGION END -----*/	//	GigeVCam::DebugThreadStateAllowed_READ
	return true;
}

//--------------------------------------------------------
/**
 *	Method      : GigeVCam::is_FrameRate_allowed()
 *	Description : Execution allowed for FrameRate attribute
 */
//--------------------------------------------------------
bool GigeVCam::is_FrameRate_allowed(TANGO_UNUSED(Tango::AttReqType type))
{
	//	Not any excluded states for FrameRate attribute in Write access.
	/*----- PROTECTED REGION ID(GigeVCam::FrameRateStateAllowed_WRITE) ENABLED START -----*/

	/*----- PROTECTED REGION END -----*/	//	GigeVCam::FrameRateStateAllowed_WRITE

	//	Not any excluded states for FrameRate attribute in read access.
	/*----- PROTECTED REGION ID(GigeVCam::FrameRateStateAllowed_READ) ENABLED START -----*/
	
	/*----- PROTECTED REGION END -----*/	//	GigeVCam::FrameRateStateAllowed_READ
	return true;
}

//--------------------------------------------------------
/**
 *	Method      : GigeVCam::is_ImageBufferSize_allowed()
 *	Description : Execution allowed for ImageBufferSize attribute
 */
//--------------------------------------------------------
bool GigeVCam::is_ImageBufferSize_allowed(TANGO_UNUSED(Tango::AttReqType type))
{
	//	Not any excluded states for ImageBufferSize attribute in Write access.
	/*----- PROTECTED REGION ID(GigeVCam::ImageBufferSizeStateAllowed_WRITE) ENABLED START -----*/

	/*----- PROTECTED REGION END -----*/	//	GigeVCam::ImageBufferSizeStateAllowed_WRITE

	//	Not any excluded states for ImageBufferSize attribute in read access.
	/*----- PROTECTED REGION ID(GigeVCam::ImageBufferSizeStateAllowed_READ) ENABLED START -----*/
	
	/*----- PROTECTED REGION END -----*/	//	GigeVCam::ImageBufferSizeStateAllowed_READ
	return true;
}

//--------------------------------------------------------
/**
 *	Method      : GigeVCam::is_ImageAcquisitionCounter_allowed()
 *	Description : Execution allowed for ImageAcquisitionCounter attribute
 */
//--------------------------------------------------------
bool GigeVCam::is_ImageAcquisitionCounter_allowed(TANGO_UNUSED(Tango::AttReqType type))
{
	//	Not any excluded states for ImageAcquisitionCounter attribute in Write access.
	/*----- PROTECTED REGION ID(GigeVCam::ImageAcquisitionCounterStateAllowed_WRITE) ENABLED START -----*/

	/*----- PROTECTED REGION END -----*/	//	GigeVCam::ImageAcquisitionCounterStateAllowed_WRITE

	//	Not any excluded states for ImageAcquisitionCounter attribute in read access.
	/*----- PROTECTED REGION ID(GigeVCam::ImageAcquisitionCounterStateAllowed_READ) ENABLED START -----*/
	
	/*----- PROTECTED REGION END -----*/	//	GigeVCam::ImageAcquisitionCounterStateAllowed_READ
	return true;
}

//--------------------------------------------------------
/**
 *	Method      : GigeVCam::is_ExposureAutoEnable_allowed()
 *	Description : Execution allowed for ExposureAutoEnable attribute
 */
//--------------------------------------------------------
bool GigeVCam::is_ExposureAutoEnable_allowed(TANGO_UNUSED(Tango::AttReqType type))
{
	//	Not any excluded states for ExposureAutoEnable attribute in Write access.
	/*----- PROTECTED REGION ID(GigeVCam::ExposureAutoEnableStateAllowed_WRITE) ENABLED START -----*/

	/*----- PROTECTED REGION END -----*/	//	GigeVCam::ExposureAutoEnableStateAllowed_WRITE

	//	Not any excluded states for ExposureAutoEnable attribute in read access.
	/*----- PROTECTED REGION ID(GigeVCam::ExposureAutoEnableStateAllowed_READ) ENABLED START -----*/
	
	/*----- PROTECTED REGION END -----*/	//	GigeVCam::ExposureAutoEnableStateAllowed_READ
	return true;
}

//--------------------------------------------------------
/**
 *	Method      : GigeVCam::is_ExposureAutoMin_allowed()
 *	Description : Execution allowed for ExposureAutoMin attribute
 */
//--------------------------------------------------------
bool GigeVCam::is_ExposureAutoMin_allowed(TANGO_UNUSED(Tango::AttReqType type))
{
	//	Not any excluded states for ExposureAutoMin attribute in Write access.
	/*----- PROTECTED REGION ID(GigeVCam::ExposureAutoMinStateAllowed_WRITE) ENABLED START -----*/

	/*----- PROTECTED REGION END -----*/	//	GigeVCam::ExposureAutoMinStateAllowed_WRITE

	//	Not any excluded states for ExposureAutoMin attribute in read access.
	/*----- PROTECTED REGION ID(GigeVCam::ExposureAutoMinStateAllowed_READ) ENABLED START -----*/
	
	/*----- PROTECTED REGION END -----*/	//	GigeVCam::ExposureAutoMinStateAllowed_READ
	return true;
}

//--------------------------------------------------------
/**
 *	Method      : GigeVCam::is_ExposureAutoMax_allowed()
 *	Description : Execution allowed for ExposureAutoMax attribute
 */
//--------------------------------------------------------
bool GigeVCam::is_ExposureAutoMax_allowed(TANGO_UNUSED(Tango::AttReqType type))
{
	//	Not any excluded states for ExposureAutoMax attribute in Write access.
	/*----- PROTECTED REGION ID(GigeVCam::ExposureAutoMaxStateAllowed_WRITE) ENABLED START -----*/

	/*----- PROTECTED REGION END -----*/	//	GigeVCam::ExposureAutoMaxStateAllowed_WRITE

	//	Not any excluded states for ExposureAutoMax attribute in read access.
	/*----- PROTECTED REGION ID(GigeVCam::ExposureAutoMaxStateAllowed_READ) ENABLED START -----*/
	
	/*----- PROTECTED REGION END -----*/	//	GigeVCam::ExposureAutoMaxStateAllowed_READ
	return true;
}

//--------------------------------------------------------
/**
 *	Method      : GigeVCam::is_GainAutoEnable_allowed()
 *	Description : Execution allowed for GainAutoEnable attribute
 */
//--------------------------------------------------------
bool GigeVCam::is_GainAutoEnable_allowed(TANGO_UNUSED(Tango::AttReqType type))
{
	//	Check access type.
	if ( type!=Tango::READ_REQ )
	{
		//	Compare device state with not allowed states for WRITE 
		if (get_state()==Tango::OFF ||
			get_state()==Tango::FAULT)
		{
		/*----- PROTECTED REGION ID(GigeVCam::GainAutoEnableStateAllowed_WRITE) ENABLED START -----*/

	/*----- PROTECTED REGION END -----*/	//	GigeVCam::GainAutoEnableStateAllowed_WRITE
			return false;
		}
		return true;
	}
	else

	//	Check access type.
	if ( type==Tango::READ_REQ )
	{
		//	Compare device state with not allowed states for READ 
		if (get_state()==Tango::OFF ||
			get_state()==Tango::FAULT)
		{
		/*----- PROTECTED REGION ID(GigeVCam::GainAutoEnableStateAllowed_READ) ENABLED START -----*/
		
		/*----- PROTECTED REGION END -----*/	//	GigeVCam::GainAutoEnableStateAllowed_READ
			return false;
		}
		return true;
	}
	return true;
}

//--------------------------------------------------------
/**
 *	Method      : GigeVCam::is_GainAutoMin_allowed()
 *	Description : Execution allowed for GainAutoMin attribute
 */
//--------------------------------------------------------
bool GigeVCam::is_GainAutoMin_allowed(TANGO_UNUSED(Tango::AttReqType type))
{
	//	Not any excluded states for GainAutoMin attribute in Write access.
	/*----- PROTECTED REGION ID(GigeVCam::GainAutoMinStateAllowed_WRITE) ENABLED START -----*/

	/*----- PROTECTED REGION END -----*/	//	GigeVCam::GainAutoMinStateAllowed_WRITE

	//	Not any excluded states for GainAutoMin attribute in read access.
	/*----- PROTECTED REGION ID(GigeVCam::GainAutoMinStateAllowed_READ) ENABLED START -----*/
	
	/*----- PROTECTED REGION END -----*/	//	GigeVCam::GainAutoMinStateAllowed_READ
	return true;
}

//--------------------------------------------------------
/**
 *	Method      : GigeVCam::is_GainAutoMax_allowed()
 *	Description : Execution allowed for GainAutoMax attribute
 */
//--------------------------------------------------------
bool GigeVCam::is_GainAutoMax_allowed(TANGO_UNUSED(Tango::AttReqType type))
{
	//	Not any excluded states for GainAutoMax attribute in Write access.
	/*----- PROTECTED REGION ID(GigeVCam::GainAutoMaxStateAllowed_WRITE) ENABLED START -----*/

	/*----- PROTECTED REGION END -----*/	//	GigeVCam::GainAutoMaxStateAllowed_WRITE

	//	Not any excluded states for GainAutoMax attribute in read access.
	/*----- PROTECTED REGION ID(GigeVCam::GainAutoMaxStateAllowed_READ) ENABLED START -----*/
	
	/*----- PROTECTED REGION END -----*/	//	GigeVCam::GainAutoMaxStateAllowed_READ
	return true;
}

//--------------------------------------------------------
/**
 *	Method      : GigeVCam::is_AutoTargetValue_allowed()
 *	Description : Execution allowed for AutoTargetValue attribute
 */
//--------------------------------------------------------
bool GigeVCam::is_AutoTargetValue_allowed(TANGO_UNUSED(Tango::AttReqType type))
{
	//	Not any excluded states for AutoTargetValue attribute in Write access.
	/*----- PROTECTED REGION ID(GigeVCam::AutoTargetValueStateAllowed_WRITE) ENABLED START -----*/

	/*----- PROTECTED REGION END -----*/	//	GigeVCam::AutoTargetValueStateAllowed_WRITE

	//	Not any excluded states for AutoTargetValue attribute in read access.
	/*----- PROTECTED REGION ID(GigeVCam::AutoTargetValueStateAllowed_READ) ENABLED START -----*/
	
	/*----- PROTECTED REGION END -----*/	//	GigeVCam::AutoTargetValueStateAllowed_READ
	return true;
}

//--------------------------------------------------------
/**
 *	Method      : GigeVCam::is_AutoFeedbackGain_allowed()
 *	Description : Execution allowed for AutoFeedbackGain attribute
 */
//--------------------------------------------------------
bool GigeVCam::is_AutoFeedbackGain_allowed(TANGO_UNUSED(Tango::AttReqType type))
{
	//	Not any excluded states for AutoFeedbackGain attribute in Write access.
	/*----- PROTECTED REGION ID(GigeVCam::AutoFeedbackGainStateAllowed_WRITE) ENABLED START -----*/

	/*----- PROTECTED REGION END -----*/	//	GigeVCam::AutoFeedbackGainStateAllowed_WRITE

	//	Not any excluded states for AutoFeedbackGain attribute in read access.
	/*----- PROTECTED REGION ID(GigeVCam::AutoFeedbackGainStateAllowed_READ) ENABLED START -----*/
	
	/*----- PROTECTED REGION END -----*/	//	GigeVCam::AutoFeedbackGainStateAllowed_READ
	return true;
}

//--------------------------------------------------------
/**
 *	Method      : GigeVCam::is_AutoFeedbackDws_allowed()
 *	Description : Execution allowed for AutoFeedbackDws attribute
 */
//--------------------------------------------------------
bool GigeVCam::is_AutoFeedbackDws_allowed(TANGO_UNUSED(Tango::AttReqType type))
{
	//	Not any excluded states for AutoFeedbackDws attribute in Write access.
	/*----- PROTECTED REGION ID(GigeVCam::AutoFeedbackDwsStateAllowed_WRITE) ENABLED START -----*/

	/*----- PROTECTED REGION END -----*/	//	GigeVCam::AutoFeedbackDwsStateAllowed_WRITE

	//	Not any excluded states for AutoFeedbackDws attribute in read access.
	/*----- PROTECTED REGION ID(GigeVCam::AutoFeedbackDwsStateAllowed_READ) ENABLED START -----*/
	
	/*----- PROTECTED REGION END -----*/	//	GigeVCam::AutoFeedbackDwsStateAllowed_READ
	return true;
}

//--------------------------------------------------------
/**
 *	Method      : GigeVCam::is_AutoFeedbackTargetThres_allowed()
 *	Description : Execution allowed for AutoFeedbackTargetThres attribute
 */
//--------------------------------------------------------
bool GigeVCam::is_AutoFeedbackTargetThres_allowed(TANGO_UNUSED(Tango::AttReqType type))
{
	//	Not any excluded states for AutoFeedbackTargetThres attribute in Write access.
	/*----- PROTECTED REGION ID(GigeVCam::AutoFeedbackTargetThresStateAllowed_WRITE) ENABLED START -----*/

	/*----- PROTECTED REGION END -----*/	//	GigeVCam::AutoFeedbackTargetThresStateAllowed_WRITE

	//	Not any excluded states for AutoFeedbackTargetThres attribute in read access.
	/*----- PROTECTED REGION ID(GigeVCam::AutoFeedbackTargetThresStateAllowed_READ) ENABLED START -----*/
	
	/*----- PROTECTED REGION END -----*/	//	GigeVCam::AutoFeedbackTargetThresStateAllowed_READ
	return true;
}

//--------------------------------------------------------
/**
 *	Method      : GigeVCam::is_AutoFeedbackDeadband_allowed()
 *	Description : Execution allowed for AutoFeedbackDeadband attribute
 */
//--------------------------------------------------------
bool GigeVCam::is_AutoFeedbackDeadband_allowed(TANGO_UNUSED(Tango::AttReqType type))
{
	//	Not any excluded states for AutoFeedbackDeadband attribute in Write access.
	/*----- PROTECTED REGION ID(GigeVCam::AutoFeedbackDeadbandStateAllowed_WRITE) ENABLED START -----*/
	
	/*----- PROTECTED REGION END -----*/	//	GigeVCam::AutoFeedbackDeadbandStateAllowed_WRITE

	//	Not any excluded states for AutoFeedbackDeadband attribute in read access.
	/*----- PROTECTED REGION ID(GigeVCam::AutoFeedbackDeadbandStateAllowed_READ) ENABLED START -----*/
	
	/*----- PROTECTED REGION END -----*/	//	GigeVCam::AutoFeedbackDeadbandStateAllowed_READ
	return true;
}

//--------------------------------------------------------
/**
 *	Method      : GigeVCam::is_FitError_allowed()
 *	Description : Execution allowed for FitError attribute
 */
//--------------------------------------------------------
bool GigeVCam::is_FitError_allowed(TANGO_UNUSED(Tango::AttReqType type))
{

	//	Not any excluded states for FitError attribute in read access.
	/*----- PROTECTED REGION ID(GigeVCam::FitErrorStateAllowed_READ) ENABLED START -----*/
	
	/*----- PROTECTED REGION END -----*/	//	GigeVCam::FitErrorStateAllowed_READ
	return true;
}

//--------------------------------------------------------
/**
 *	Method      : GigeVCam::is_BunchNumber_allowed()
 *	Description : Execution allowed for BunchNumber attribute
 */
//--------------------------------------------------------
bool GigeVCam::is_BunchNumber_allowed(TANGO_UNUSED(Tango::AttReqType type))
{

	//	Not any excluded states for BunchNumber attribute in read access.
	/*----- PROTECTED REGION ID(GigeVCam::BunchNumberStateAllowed_READ) ENABLED START -----*/
	
	/*----- PROTECTED REGION END -----*/	//	GigeVCam::BunchNumberStateAllowed_READ
	return true;
}

//--------------------------------------------------------
/**
 *	Method      : GigeVCam::is_MeanIntensityThreshold_allowed()
 *	Description : Execution allowed for MeanIntensityThreshold attribute
 */
//--------------------------------------------------------
bool GigeVCam::is_MeanIntensityThreshold_allowed(TANGO_UNUSED(Tango::AttReqType type))
{
	//	Not any excluded states for MeanIntensityThreshold attribute in Write access.
	/*----- PROTECTED REGION ID(GigeVCam::MeanIntensityThresholdStateAllowed_WRITE) ENABLED START -----*/

	/*----- PROTECTED REGION END -----*/	//	GigeVCam::MeanIntensityThresholdStateAllowed_WRITE

	//	Not any excluded states for MeanIntensityThreshold attribute in read access.
	/*----- PROTECTED REGION ID(GigeVCam::MeanIntensityThresholdStateAllowed_READ) ENABLED START -----*/
	
	/*----- PROTECTED REGION END -----*/	//	GigeVCam::MeanIntensityThresholdStateAllowed_READ
	return true;
}

//--------------------------------------------------------
/**
 *	Method      : GigeVCam::is_Binning_allowed()
 *	Description : Execution allowed for Binning attribute
 */
//--------------------------------------------------------
bool GigeVCam::is_Binning_allowed(TANGO_UNUSED(Tango::AttReqType type))
{
	//	Not any excluded states for Binning attribute in Write access.
	/*----- PROTECTED REGION ID(GigeVCam::BinningStateAllowed_WRITE) ENABLED START -----*/

	/*----- PROTECTED REGION END -----*/	//	GigeVCam::BinningStateAllowed_WRITE

	//	Check access type.
	if ( type==Tango::READ_REQ )
	{
		//	Compare device state with not allowed states for READ 
		if (get_state()==Tango::OFF ||
			get_state()==Tango::FAULT)
		{
		/*----- PROTECTED REGION ID(GigeVCam::BinningStateAllowed_READ) ENABLED START -----*/
		
		/*----- PROTECTED REGION END -----*/	//	GigeVCam::BinningStateAllowed_READ
			return false;
		}
		return true;
	}
	return true;
}

//--------------------------------------------------------
/**
 *	Method      : GigeVCam::is_DISEnable_allowed()
 *	Description : Execution allowed for DISEnable attribute
 */
//--------------------------------------------------------
bool GigeVCam::is_DISEnable_allowed(TANGO_UNUSED(Tango::AttReqType type))
{
	//	Not any excluded states for DISEnable attribute in Write access.
	/*----- PROTECTED REGION ID(GigeVCam::DISEnableStateAllowed_WRITE) ENABLED START -----*/

	/*----- PROTECTED REGION END -----*/	//	GigeVCam::DISEnableStateAllowed_WRITE

	//	Not any excluded states for DISEnable attribute in read access.
	/*----- PROTECTED REGION ID(GigeVCam::DISEnableStateAllowed_READ) ENABLED START -----*/
	
	/*----- PROTECTED REGION END -----*/	//	GigeVCam::DISEnableStateAllowed_READ
	return true;
}

//--------------------------------------------------------
/**
 *	Method      : GigeVCam::is_DisableTriggerTimeout_allowed()
 *	Description : Execution allowed for DisableTriggerTimeout attribute
 */
//--------------------------------------------------------
bool GigeVCam::is_DisableTriggerTimeout_allowed(TANGO_UNUSED(Tango::AttReqType type))
{
	//	Not any excluded states for DisableTriggerTimeout attribute in Write access.
	/*----- PROTECTED REGION ID(GigeVCam::DisableTriggerTimeoutStateAllowed_WRITE) ENABLED START -----*/

	/*----- PROTECTED REGION END -----*/	//	GigeVCam::DisableTriggerTimeoutStateAllowed_WRITE

	//	Not any excluded states for DisableTriggerTimeout attribute in read access.
	/*----- PROTECTED REGION ID(GigeVCam::DisableTriggerTimeoutStateAllowed_READ) ENABLED START -----*/
	
	/*----- PROTECTED REGION END -----*/	//	GigeVCam::DisableTriggerTimeoutStateAllowed_READ
	return true;
}

//--------------------------------------------------------
/**
 *	Method      : GigeVCam::is_ImageSumSamples_allowed()
 *	Description : Execution allowed for ImageSumSamples attribute
 */
//--------------------------------------------------------
bool GigeVCam::is_ImageSumSamples_allowed(TANGO_UNUSED(Tango::AttReqType type))
{
	//	Not any excluded states for ImageSumSamples attribute in Write access.
	/*----- PROTECTED REGION ID(GigeVCam::ImageSumSamplesStateAllowed_WRITE) ENABLED START -----*/
	
	/*----- PROTECTED REGION END -----*/	//	GigeVCam::ImageSumSamplesStateAllowed_WRITE

	//	Not any excluded states for ImageSumSamples attribute in read access.
	/*----- PROTECTED REGION ID(GigeVCam::ImageSumSamplesStateAllowed_READ) ENABLED START -----*/
	
	/*----- PROTECTED REGION END -----*/	//	GigeVCam::ImageSumSamplesStateAllowed_READ
	return true;
}

//--------------------------------------------------------
/**
 *	Method      : GigeVCam::is_Model_allowed()
 *	Description : Execution allowed for Model attribute
 */
//--------------------------------------------------------
bool GigeVCam::is_Model_allowed(TANGO_UNUSED(Tango::AttReqType type))
{

	//	Not any excluded states for Model attribute in read access.
	/*----- PROTECTED REGION ID(GigeVCam::ModelStateAllowed_READ) ENABLED START -----*/
	
	/*----- PROTECTED REGION END -----*/	//	GigeVCam::ModelStateAllowed_READ
	return true;
}

//--------------------------------------------------------
/**
 *	Method      : GigeVCam::is_FeedbackMode_allowed()
 *	Description : Execution allowed for FeedbackMode attribute
 */
//--------------------------------------------------------
bool GigeVCam::is_FeedbackMode_allowed(TANGO_UNUSED(Tango::AttReqType type))
{
	//	Not any excluded states for FeedbackMode attribute in Write access.
	/*----- PROTECTED REGION ID(GigeVCam::FeedbackModeStateAllowed_WRITE) ENABLED START -----*/
	
	/*----- PROTECTED REGION END -----*/	//	GigeVCam::FeedbackModeStateAllowed_WRITE

	//	Not any excluded states for FeedbackMode attribute in read access.
	/*----- PROTECTED REGION ID(GigeVCam::FeedbackModeStateAllowed_READ) ENABLED START -----*/
	
	/*----- PROTECTED REGION END -----*/	//	GigeVCam::FeedbackModeStateAllowed_READ
	return true;
}

//--------------------------------------------------------
/**
 *	Method      : GigeVCam::is_MeanIntensity_allowed()
 *	Description : Execution allowed for MeanIntensity attribute
 */
//--------------------------------------------------------
bool GigeVCam::is_MeanIntensity_allowed(TANGO_UNUSED(Tango::AttReqType type))
{

	//	Not any excluded states for MeanIntensity attribute in read access.
	/*----- PROTECTED REGION ID(GigeVCam::MeanIntensityStateAllowed_READ) ENABLED START -----*/
	
	/*----- PROTECTED REGION END -----*/	//	GigeVCam::MeanIntensityStateAllowed_READ
	return true;
}

//--------------------------------------------------------
/**
 *	Method      : GigeVCam::is_FeedbackError_allowed()
 *	Description : Execution allowed for FeedbackError attribute
 */
//--------------------------------------------------------
bool GigeVCam::is_FeedbackError_allowed(TANGO_UNUSED(Tango::AttReqType type))
{

	//	Not any excluded states for FeedbackError attribute in read access.
	/*----- PROTECTED REGION ID(GigeVCam::FeedbackErrorStateAllowed_READ) ENABLED START -----*/
	
	/*----- PROTECTED REGION END -----*/	//	GigeVCam::FeedbackErrorStateAllowed_READ
	return true;
}

//--------------------------------------------------------
/**
 *	Method      : GigeVCam::is_EnableMedianFilter_allowed()
 *	Description : Execution allowed for EnableMedianFilter attribute
 */
//--------------------------------------------------------
bool GigeVCam::is_EnableMedianFilter_allowed(TANGO_UNUSED(Tango::AttReqType type))
{
	//	Not any excluded states for EnableMedianFilter attribute in Write access.
	/*----- PROTECTED REGION ID(GigeVCam::EnableMedianFilterStateAllowed_WRITE) ENABLED START -----*/
	
	/*----- PROTECTED REGION END -----*/	//	GigeVCam::EnableMedianFilterStateAllowed_WRITE

	//	Not any excluded states for EnableMedianFilter attribute in read access.
	/*----- PROTECTED REGION ID(GigeVCam::EnableMedianFilterStateAllowed_READ) ENABLED START -----*/
	
	/*----- PROTECTED REGION END -----*/	//	GigeVCam::EnableMedianFilterStateAllowed_READ
	return true;
}

//--------------------------------------------------------
/**
 *	Method      : GigeVCam::is_Permutation_allowed()
 *	Description : Execution allowed for Permutation attribute
 */
//--------------------------------------------------------
bool GigeVCam::is_Permutation_allowed(TANGO_UNUSED(Tango::AttReqType type))
{
	//	Not any excluded states for Permutation attribute in Write access.
	/*----- PROTECTED REGION ID(GigeVCam::PermutationStateAllowed_WRITE) ENABLED START -----*/
	
	/*----- PROTECTED REGION END -----*/	//	GigeVCam::PermutationStateAllowed_WRITE

	//	Check access type.
	if ( type==Tango::READ_REQ )
	{
		//	Compare device state with not allowed states for READ 
		if (get_state()==Tango::OFF ||
			get_state()==Tango::FAULT)
		{
		/*----- PROTECTED REGION ID(GigeVCam::PermutationStateAllowed_READ) ENABLED START -----*/
		
		/*----- PROTECTED REGION END -----*/	//	GigeVCam::PermutationStateAllowed_READ
			return false;
		}
		return true;
	}
	return true;
}

//--------------------------------------------------------
/**
 *	Method      : GigeVCam::is_MasterCamera_allowed()
 *	Description : Execution allowed for MasterCamera attribute
 */
//--------------------------------------------------------
bool GigeVCam::is_MasterCamera_allowed(TANGO_UNUSED(Tango::AttReqType type))
{

	//	Not any excluded states for MasterCamera attribute in read access.
	/*----- PROTECTED REGION ID(GigeVCam::MasterCameraStateAllowed_READ) ENABLED START -----*/
	
	/*----- PROTECTED REGION END -----*/	//	GigeVCam::MasterCameraStateAllowed_READ
	return true;
}

//--------------------------------------------------------
/**
 *	Method      : GigeVCam::is_NumAverageFrames_allowed()
 *	Description : Execution allowed for NumAverageFrames attribute
 */
//--------------------------------------------------------
bool GigeVCam::is_NumAverageFrames_allowed(TANGO_UNUSED(Tango::AttReqType type))
{
	//	Not any excluded states for NumAverageFrames attribute in Write access.
	/*----- PROTECTED REGION ID(GigeVCam::NumAverageFramesStateAllowed_WRITE) ENABLED START -----*/
	
	/*----- PROTECTED REGION END -----*/	//	GigeVCam::NumAverageFramesStateAllowed_WRITE

	//	Not any excluded states for NumAverageFrames attribute in read access.
	/*----- PROTECTED REGION ID(GigeVCam::NumAverageFramesStateAllowed_READ) ENABLED START -----*/
	
	/*----- PROTECTED REGION END -----*/	//	GigeVCam::NumAverageFramesStateAllowed_READ
	return true;
}

//--------------------------------------------------------
/**
 *	Method      : GigeVCam::is_SearchBackgroundParam_allowed()
 *	Description : Execution allowed for SearchBackgroundParam attribute
 */
//--------------------------------------------------------
bool GigeVCam::is_SearchBackgroundParam_allowed(TANGO_UNUSED(Tango::AttReqType type))
{
	//	Not any excluded states for SearchBackgroundParam attribute in Write access.
	/*----- PROTECTED REGION ID(GigeVCam::SearchBackgroundParamStateAllowed_WRITE) ENABLED START -----*/

	/*----- PROTECTED REGION END -----*/	//	GigeVCam::SearchBackgroundParamStateAllowed_WRITE

	//	Not any excluded states for SearchBackgroundParam attribute in read access.
	/*----- PROTECTED REGION ID(GigeVCam::SearchBackgroundParamStateAllowed_READ) ENABLED START -----*/
	
	/*----- PROTECTED REGION END -----*/	//	GigeVCam::SearchBackgroundParamStateAllowed_READ
	return true;
}

//--------------------------------------------------------
/**
 *	Method      : GigeVCam::is_HorProfile_allowed()
 *	Description : Execution allowed for HorProfile attribute
 */
//--------------------------------------------------------
bool GigeVCam::is_HorProfile_allowed(TANGO_UNUSED(Tango::AttReqType type))
{

	//	Check access type.
	if ( type==Tango::READ_REQ )
	{
		//	Compare device state with not allowed states for READ 
		if (get_state()==Tango::OFF ||
			get_state()==Tango::FAULT)
		{
		/*----- PROTECTED REGION ID(GigeVCam::HorProfileStateAllowed_READ) ENABLED START -----*/
		
		/*----- PROTECTED REGION END -----*/	//	GigeVCam::HorProfileStateAllowed_READ
			return false;
		}
		return true;
	}
	return true;
}

//--------------------------------------------------------
/**
 *	Method      : GigeVCam::is_VerProfile_allowed()
 *	Description : Execution allowed for VerProfile attribute
 */
//--------------------------------------------------------
bool GigeVCam::is_VerProfile_allowed(TANGO_UNUSED(Tango::AttReqType type))
{

	//	Check access type.
	if ( type==Tango::READ_REQ )
	{
		//	Compare device state with not allowed states for READ 
		if (get_state()==Tango::OFF ||
			get_state()==Tango::FAULT)
		{
		/*----- PROTECTED REGION ID(GigeVCam::VerProfileStateAllowed_READ) ENABLED START -----*/
		
		/*----- PROTECTED REGION END -----*/	//	GigeVCam::VerProfileStateAllowed_READ
			return false;
		}
		return true;
	}
	return true;
}

//--------------------------------------------------------
/**
 *	Method      : GigeVCam::is_ErrorCounters_allowed()
 *	Description : Execution allowed for ErrorCounters attribute
 */
//--------------------------------------------------------
bool GigeVCam::is_ErrorCounters_allowed(TANGO_UNUSED(Tango::AttReqType type))
{

	//	Check access type.
	if ( type==Tango::READ_REQ )
	{
		//	Compare device state with not allowed states for READ 
		if (get_state()==Tango::OFF ||
			get_state()==Tango::FAULT)
		{
		/*----- PROTECTED REGION ID(GigeVCam::ErrorCountersStateAllowed_READ) ENABLED START -----*/
		
		/*----- PROTECTED REGION END -----*/	//	GigeVCam::ErrorCountersStateAllowed_READ
			return false;
		}
		return true;
	}
	return true;
}

//--------------------------------------------------------
/**
 *	Method      : GigeVCam::is_TimeStamp_allowed()
 *	Description : Execution allowed for TimeStamp attribute
 */
//--------------------------------------------------------
bool GigeVCam::is_TimeStamp_allowed(TANGO_UNUSED(Tango::AttReqType type))
{

	//	Check access type.
	if ( type==Tango::READ_REQ )
	{
		//	Compare device state with not allowed states for READ 
		if (get_state()==Tango::OFF ||
			get_state()==Tango::FAULT)
		{
		/*----- PROTECTED REGION ID(GigeVCam::TimeStampStateAllowed_READ) ENABLED START -----*/
		
		/*----- PROTECTED REGION END -----*/	//	GigeVCam::TimeStampStateAllowed_READ
			return false;
		}
		return true;
	}
	return true;
}

//--------------------------------------------------------
/**
 *	Method      : GigeVCam::is_AutoRoiParam_allowed()
 *	Description : Execution allowed for AutoRoiParam attribute
 */
//--------------------------------------------------------
bool GigeVCam::is_AutoRoiParam_allowed(TANGO_UNUSED(Tango::AttReqType type))
{

	//	Check access type.
	if ( type==Tango::READ_REQ )
	{
		//	Compare device state with not allowed states for READ 
		if (get_state()==Tango::OFF ||
			get_state()==Tango::FAULT)
		{
		/*----- PROTECTED REGION ID(GigeVCam::AutoRoiParamStateAllowed_READ) ENABLED START -----*/
		
		/*----- PROTECTED REGION END -----*/	//	GigeVCam::AutoRoiParamStateAllowed_READ
			return false;
		}
		return true;
	}
	return true;
}

//--------------------------------------------------------
/**
 *	Method      : GigeVCam::is_RoiParam_allowed()
 *	Description : Execution allowed for RoiParam attribute
 */
//--------------------------------------------------------
bool GigeVCam::is_RoiParam_allowed(TANGO_UNUSED(Tango::AttReqType type))
{
	//	Not any excluded states for RoiParam attribute in Write access.
	/*----- PROTECTED REGION ID(GigeVCam::RoiParamStateAllowed_WRITE) ENABLED START -----*/

	/*----- PROTECTED REGION END -----*/	//	GigeVCam::RoiParamStateAllowed_WRITE

	//	Not any excluded states for RoiParam attribute in read access.
	/*----- PROTECTED REGION ID(GigeVCam::RoiParamStateAllowed_READ) ENABLED START -----*/
	
	/*----- PROTECTED REGION END -----*/	//	GigeVCam::RoiParamStateAllowed_READ
	return true;
}

//--------------------------------------------------------
/**
 *	Method      : GigeVCam::is_HorFitProfile_allowed()
 *	Description : Execution allowed for HorFitProfile attribute
 */
//--------------------------------------------------------
bool GigeVCam::is_HorFitProfile_allowed(TANGO_UNUSED(Tango::AttReqType type))
{

	//	Check access type.
	if ( type==Tango::READ_REQ )
	{
		//	Compare device state with not allowed states for READ 
		if (get_state()==Tango::OFF ||
			get_state()==Tango::FAULT)
		{
		/*----- PROTECTED REGION ID(GigeVCam::HorFitProfileStateAllowed_READ) ENABLED START -----*/
		
		/*----- PROTECTED REGION END -----*/	//	GigeVCam::HorFitProfileStateAllowed_READ
			return false;
		}
		return true;
	}
	return true;
}

//--------------------------------------------------------
/**
 *	Method      : GigeVCam::is_VerFitProfile_allowed()
 *	Description : Execution allowed for VerFitProfile attribute
 */
//--------------------------------------------------------
bool GigeVCam::is_VerFitProfile_allowed(TANGO_UNUSED(Tango::AttReqType type))
{

	//	Check access type.
	if ( type==Tango::READ_REQ )
	{
		//	Compare device state with not allowed states for READ 
		if (get_state()==Tango::OFF ||
			get_state()==Tango::FAULT)
		{
		/*----- PROTECTED REGION ID(GigeVCam::VerFitProfileStateAllowed_READ) ENABLED START -----*/
		
		/*----- PROTECTED REGION END -----*/	//	GigeVCam::VerFitProfileStateAllowed_READ
			return false;
		}
		return true;
	}
	return true;
}

//--------------------------------------------------------
/**
 *	Method      : GigeVCam::is_HwRoiParam_allowed()
 *	Description : Execution allowed for HwRoiParam attribute
 */
//--------------------------------------------------------
bool GigeVCam::is_HwRoiParam_allowed(TANGO_UNUSED(Tango::AttReqType type))
{
	//	Not any excluded states for HwRoiParam attribute in Write access.
	/*----- PROTECTED REGION ID(GigeVCam::HwRoiParamStateAllowed_WRITE) ENABLED START -----*/

	/*----- PROTECTED REGION END -----*/	//	GigeVCam::HwRoiParamStateAllowed_WRITE

	//	Not any excluded states for HwRoiParam attribute in read access.
	/*----- PROTECTED REGION ID(GigeVCam::HwRoiParamStateAllowed_READ) ENABLED START -----*/
	
	/*----- PROTECTED REGION END -----*/	//	GigeVCam::HwRoiParamStateAllowed_READ
	return true;
}

//--------------------------------------------------------
/**
 *	Method      : GigeVCam::is_Image8_allowed()
 *	Description : Execution allowed for Image8 attribute
 */
//--------------------------------------------------------
bool GigeVCam::is_Image8_allowed(TANGO_UNUSED(Tango::AttReqType type))
{

	//	Check access type.
	if ( type==Tango::READ_REQ )
	{
		//	Compare device state with not allowed states for READ 
		if (get_state()==Tango::OFF ||
			get_state()==Tango::FAULT)
		{
		/*----- PROTECTED REGION ID(GigeVCam::Image8StateAllowed_READ) ENABLED START -----*/
		
		/*----- PROTECTED REGION END -----*/	//	GigeVCam::Image8StateAllowed_READ
			return false;
		}
		return true;
	}
	return true;
}

//--------------------------------------------------------
/**
 *	Method      : GigeVCam::is_Image8Icon_allowed()
 *	Description : Execution allowed for Image8Icon attribute
 */
//--------------------------------------------------------
bool GigeVCam::is_Image8Icon_allowed(TANGO_UNUSED(Tango::AttReqType type))
{

	//	Check access type.
	if ( type==Tango::READ_REQ )
	{
		//	Compare device state with not allowed states for READ 
		if (get_state()==Tango::OFF ||
			get_state()==Tango::FAULT)
		{
		/*----- PROTECTED REGION ID(GigeVCam::Image8IconStateAllowed_READ) ENABLED START -----*/
		
		/*----- PROTECTED REGION END -----*/	//	GigeVCam::Image8IconStateAllowed_READ
			return false;
		}
		return true;
	}
	return true;
}

//--------------------------------------------------------
/**
 *	Method      : GigeVCam::is_Image16_allowed()
 *	Description : Execution allowed for Image16 attribute
 */
//--------------------------------------------------------
bool GigeVCam::is_Image16_allowed(TANGO_UNUSED(Tango::AttReqType type))
{

	//	Check access type.
	if ( type==Tango::READ_REQ )
	{
		//	Compare device state with not allowed states for READ 
		if (get_state()==Tango::OFF ||
			get_state()==Tango::FAULT)
		{
		/*----- PROTECTED REGION ID(GigeVCam::Image16StateAllowed_READ) ENABLED START -----*/
		
		/*----- PROTECTED REGION END -----*/	//	GigeVCam::Image16StateAllowed_READ
			return false;
		}
		return true;
	}
	return true;
}

//--------------------------------------------------------
/**
 *	Method      : GigeVCam::is_Image16Icon_allowed()
 *	Description : Execution allowed for Image16Icon attribute
 */
//--------------------------------------------------------
bool GigeVCam::is_Image16Icon_allowed(TANGO_UNUSED(Tango::AttReqType type))
{

	//	Check access type.
	if ( type==Tango::READ_REQ )
	{
		//	Compare device state with not allowed states for READ 
		if (get_state()==Tango::OFF ||
			get_state()==Tango::FAULT)
		{
		/*----- PROTECTED REGION ID(GigeVCam::Image16IconStateAllowed_READ) ENABLED START -----*/
		
		/*----- PROTECTED REGION END -----*/	//	GigeVCam::Image16IconStateAllowed_READ
			return false;
		}
		return true;
	}
	return true;
}

//--------------------------------------------------------
/**
 *	Method      : GigeVCam::is_Image8Counter_allowed()
 *	Description : Execution allowed for Image8Counter attribute
 */
//--------------------------------------------------------
bool GigeVCam::is_Image8Counter_allowed(TANGO_UNUSED(Tango::AttReqType type))
{

	//	Not any excluded states for Image8Counter attribute in read access.
	/*----- PROTECTED REGION ID(GigeVCam::Image8CounterStateAllowed_READ) ENABLED START -----*/
	
	/*----- PROTECTED REGION END -----*/	//	GigeVCam::Image8CounterStateAllowed_READ
	return true;
}

//--------------------------------------------------------
/**
 *	Method      : GigeVCam::is_Image16Counter_allowed()
 *	Description : Execution allowed for Image16Counter attribute
 */
//--------------------------------------------------------
bool GigeVCam::is_Image16Counter_allowed(TANGO_UNUSED(Tango::AttReqType type))
{

	//	Not any excluded states for Image16Counter attribute in read access.
	/*----- PROTECTED REGION ID(GigeVCam::Image16CounterStateAllowed_READ) ENABLED START -----*/
	
	/*----- PROTECTED REGION END -----*/	//	GigeVCam::Image16CounterStateAllowed_READ
	return true;
}

//--------------------------------------------------------
/**
 *	Method      : GigeVCam::is_ImageSum_allowed()
 *	Description : Execution allowed for ImageSum attribute
 */
//--------------------------------------------------------
bool GigeVCam::is_ImageSum_allowed(TANGO_UNUSED(Tango::AttReqType type))
{

	//	Not any excluded states for ImageSum attribute in read access.
	/*----- PROTECTED REGION ID(GigeVCam::ImageSumStateAllowed_READ) ENABLED START -----*/
	
	/*----- PROTECTED REGION END -----*/	//	GigeVCam::ImageSumStateAllowed_READ
	return true;
}


//=================================================
//		Commands Allowed Methods
//=================================================

//--------------------------------------------------------
/**
 *	Method      : GigeVCam::is_Start_allowed()
 *	Description : Execution allowed for Start attribute
 */
//--------------------------------------------------------
bool GigeVCam::is_Start_allowed(TANGO_UNUSED(const CORBA::Any &any))
{
	//	Compare device state with not allowed states.
	if (get_state()==Tango::ON ||
		get_state()==Tango::ALARM)
	{
	/*----- PROTECTED REGION ID(GigeVCam::StartStateAllowed) ENABLED START -----*/

	/*----- PROTECTED REGION END -----*/	//	GigeVCam::StartStateAllowed
		return false;
	}
	return true;
}

//--------------------------------------------------------
/**
 *	Method      : GigeVCam::is_Stop_allowed()
 *	Description : Execution allowed for Stop attribute
 */
//--------------------------------------------------------
bool GigeVCam::is_Stop_allowed(TANGO_UNUSED(const CORBA::Any &any))
{
	//	Not any excluded states for Stop command.
	/*----- PROTECTED REGION ID(GigeVCam::StopStateAllowed) ENABLED START -----*/

	/*----- PROTECTED REGION END -----*/	//	GigeVCam::StopStateAllowed
	return true;
}

//--------------------------------------------------------
/**
 *	Method      : GigeVCam::is_Reset_allowed()
 *	Description : Execution allowed for Reset attribute
 */
//--------------------------------------------------------
bool GigeVCam::is_Reset_allowed(TANGO_UNUSED(const CORBA::Any &any))
{
	//	Not any excluded states for Reset command.
	/*----- PROTECTED REGION ID(GigeVCam::ResetStateAllowed) ENABLED START -----*/

	/*----- PROTECTED REGION END -----*/	//	GigeVCam::ResetStateAllowed
	return true;
}

//--------------------------------------------------------
/**
 *	Method      : GigeVCam::is_ListCamera_allowed()
 *	Description : Execution allowed for ListCamera attribute
 */
//--------------------------------------------------------
bool GigeVCam::is_ListCamera_allowed(TANGO_UNUSED(const CORBA::Any &any))
{
	//	Not any excluded states for ListCamera command.
	/*----- PROTECTED REGION ID(GigeVCam::ListCameraStateAllowed) ENABLED START -----*/

	/*----- PROTECTED REGION END -----*/	//	GigeVCam::ListCameraStateAllowed
	return true;
}

//--------------------------------------------------------
/**
 *	Method      : GigeVCam::is_AcquireBackground_allowed()
 *	Description : Execution allowed for AcquireBackground attribute
 */
//--------------------------------------------------------
bool GigeVCam::is_AcquireBackground_allowed(TANGO_UNUSED(const CORBA::Any &any))
{
	//	Compare device state with not allowed states.
	if (get_state()==Tango::OFF ||
		get_state()==Tango::FAULT)
	{
	/*----- PROTECTED REGION ID(GigeVCam::AcquireBackgroundStateAllowed) ENABLED START -----*/

	/*----- PROTECTED REGION END -----*/	//	GigeVCam::AcquireBackgroundStateAllowed
		return false;
	}
	return true;
}

//--------------------------------------------------------
/**
 *	Method      : GigeVCam::is_GetImage8_allowed()
 *	Description : Execution allowed for GetImage8 attribute
 */
//--------------------------------------------------------
bool GigeVCam::is_GetImage8_allowed(TANGO_UNUSED(const CORBA::Any &any))
{
	//	Compare device state with not allowed states.
	if (get_state()==Tango::OFF ||
		get_state()==Tango::FAULT)
	{
	/*----- PROTECTED REGION ID(GigeVCam::GetImage8StateAllowed) ENABLED START -----*/

	/*----- PROTECTED REGION END -----*/	//	GigeVCam::GetImage8StateAllowed
		return false;
	}
	return true;
}

//--------------------------------------------------------
/**
 *	Method      : GigeVCam::is_GetImage16_allowed()
 *	Description : Execution allowed for GetImage16 attribute
 */
//--------------------------------------------------------
bool GigeVCam::is_GetImage16_allowed(TANGO_UNUSED(const CORBA::Any &any))
{
	//	Compare device state with not allowed states.
	if (get_state()==Tango::OFF ||
		get_state()==Tango::FAULT)
	{
	/*----- PROTECTED REGION ID(GigeVCam::GetImage16StateAllowed) ENABLED START -----*/

	/*----- PROTECTED REGION END -----*/	//	GigeVCam::GetImage16StateAllowed
		return false;
	}
	return true;
}

//--------------------------------------------------------
/**
 *	Method      : GigeVCam::is_GetHorPos_allowed()
 *	Description : Execution allowed for GetHorPos attribute
 */
//--------------------------------------------------------
bool GigeVCam::is_GetHorPos_allowed(TANGO_UNUSED(const CORBA::Any &any))
{
	//	Compare device state with not allowed states.
	if (get_state()==Tango::OFF ||
		get_state()==Tango::FAULT)
	{
	/*----- PROTECTED REGION ID(GigeVCam::GetHorPosStateAllowed) ENABLED START -----*/

	/*----- PROTECTED REGION END -----*/	//	GigeVCam::GetHorPosStateAllowed
		return false;
	}
	return true;
}

//--------------------------------------------------------
/**
 *	Method      : GigeVCam::is_GetVerPos_allowed()
 *	Description : Execution allowed for GetVerPos attribute
 */
//--------------------------------------------------------
bool GigeVCam::is_GetVerPos_allowed(TANGO_UNUSED(const CORBA::Any &any))
{
	//	Compare device state with not allowed states.
	if (get_state()==Tango::OFF ||
		get_state()==Tango::FAULT)
	{
	/*----- PROTECTED REGION ID(GigeVCam::GetVerPosStateAllowed) ENABLED START -----*/

	/*----- PROTECTED REGION END -----*/	//	GigeVCam::GetVerPosStateAllowed
		return false;
	}
	return true;
}

//--------------------------------------------------------
/**
 *	Method      : GigeVCam::is_GetHorSigma_allowed()
 *	Description : Execution allowed for GetHorSigma attribute
 */
//--------------------------------------------------------
bool GigeVCam::is_GetHorSigma_allowed(TANGO_UNUSED(const CORBA::Any &any))
{
	//	Compare device state with not allowed states.
	if (get_state()==Tango::OFF ||
		get_state()==Tango::FAULT)
	{
	/*----- PROTECTED REGION ID(GigeVCam::GetHorSigmaStateAllowed) ENABLED START -----*/

	/*----- PROTECTED REGION END -----*/	//	GigeVCam::GetHorSigmaStateAllowed
		return false;
	}
	return true;
}

//--------------------------------------------------------
/**
 *	Method      : GigeVCam::is_GetVerSigma_allowed()
 *	Description : Execution allowed for GetVerSigma attribute
 */
//--------------------------------------------------------
bool GigeVCam::is_GetVerSigma_allowed(TANGO_UNUSED(const CORBA::Any &any))
{
	//	Compare device state with not allowed states.
	if (get_state()==Tango::OFF ||
		get_state()==Tango::FAULT)
	{
	/*----- PROTECTED REGION ID(GigeVCam::GetVerSigmaStateAllowed) ENABLED START -----*/

	/*----- PROTECTED REGION END -----*/	//	GigeVCam::GetVerSigmaStateAllowed
		return false;
	}
	return true;
}

//--------------------------------------------------------
/**
 *	Method      : GigeVCam::is_GetArea_allowed()
 *	Description : Execution allowed for GetArea attribute
 */
//--------------------------------------------------------
bool GigeVCam::is_GetArea_allowed(TANGO_UNUSED(const CORBA::Any &any))
{
	//	Compare device state with not allowed states.
	if (get_state()==Tango::OFF ||
		get_state()==Tango::FAULT)
	{
	/*----- PROTECTED REGION ID(GigeVCam::GetAreaStateAllowed) ENABLED START -----*/

	/*----- PROTECTED REGION END -----*/	//	GigeVCam::GetAreaStateAllowed
		return false;
	}
	return true;
}

//--------------------------------------------------------
/**
 *	Method      : GigeVCam::is_GetAcquisitionCounter_allowed()
 *	Description : Execution allowed for GetAcquisitionCounter attribute
 */
//--------------------------------------------------------
bool GigeVCam::is_GetAcquisitionCounter_allowed(TANGO_UNUSED(const CORBA::Any &any))
{
	//	Compare device state with not allowed states.
	if (get_state()==Tango::OFF ||
		get_state()==Tango::FAULT)
	{
	/*----- PROTECTED REGION ID(GigeVCam::GetAcquisitionCounterStateAllowed) ENABLED START -----*/

	/*----- PROTECTED REGION END -----*/	//	GigeVCam::GetAcquisitionCounterStateAllowed
		return false;
	}
	return true;
}

//--------------------------------------------------------
/**
 *	Method      : GigeVCam::is_GetSaturation_allowed()
 *	Description : Execution allowed for GetSaturation attribute
 */
//--------------------------------------------------------
bool GigeVCam::is_GetSaturation_allowed(TANGO_UNUSED(const CORBA::Any &any))
{
	//	Compare device state with not allowed states.
	if (get_state()==Tango::OFF ||
		get_state()==Tango::FAULT)
	{
	/*----- PROTECTED REGION ID(GigeVCam::GetSaturationStateAllowed) ENABLED START -----*/

	/*----- PROTECTED REGION END -----*/	//	GigeVCam::GetSaturationStateAllowed
		return false;
	}
	return true;
}

//--------------------------------------------------------
/**
 *	Method      : GigeVCam::is_SetReference_allowed()
 *	Description : Execution allowed for SetReference attribute
 */
//--------------------------------------------------------
bool GigeVCam::is_SetReference_allowed(TANGO_UNUSED(const CORBA::Any &any))
{
	//	Not any excluded states for SetReference command.
	/*----- PROTECTED REGION ID(GigeVCam::SetReferenceStateAllowed) ENABLED START -----*/

	/*----- PROTECTED REGION END -----*/	//	GigeVCam::SetReferenceStateAllowed
	return true;
}

//--------------------------------------------------------
/**
 *	Method      : GigeVCam::is_GetPhase_allowed()
 *	Description : Execution allowed for GetPhase attribute
 */
//--------------------------------------------------------
bool GigeVCam::is_GetPhase_allowed(TANGO_UNUSED(const CORBA::Any &any))
{
	//	Compare device state with not allowed states.
	if (get_state()==Tango::OFF ||
		get_state()==Tango::FAULT)
	{
	/*----- PROTECTED REGION ID(GigeVCam::GetPhaseStateAllowed) ENABLED START -----*/

	/*----- PROTECTED REGION END -----*/	//	GigeVCam::GetPhaseStateAllowed
		return false;
	}
	return true;
}

//--------------------------------------------------------
/**
 *	Method      : GigeVCam::is_SaveScale_allowed()
 *	Description : Execution allowed for SaveScale attribute
 */
//--------------------------------------------------------
bool GigeVCam::is_SaveScale_allowed(TANGO_UNUSED(const CORBA::Any &any))
{
	//	Compare device state with not allowed states.
	if (get_state()==Tango::OFF ||
		get_state()==Tango::FAULT)
	{
	/*----- PROTECTED REGION ID(GigeVCam::SaveScaleStateAllowed) ENABLED START -----*/

	/*----- PROTECTED REGION END -----*/	//	GigeVCam::SaveScaleStateAllowed
		return false;
	}
	return true;
}

//--------------------------------------------------------
/**
 *	Method      : GigeVCam::is_RestoreScale_allowed()
 *	Description : Execution allowed for RestoreScale attribute
 */
//--------------------------------------------------------
bool GigeVCam::is_RestoreScale_allowed(TANGO_UNUSED(const CORBA::Any &any))
{
	//	Compare device state with not allowed states.
	if (get_state()==Tango::OFF ||
		get_state()==Tango::FAULT)
	{
	/*----- PROTECTED REGION ID(GigeVCam::RestoreScaleStateAllowed) ENABLED START -----*/

	/*----- PROTECTED REGION END -----*/	//	GigeVCam::RestoreScaleStateAllowed
		return false;
	}
	return true;
}

//--------------------------------------------------------
/**
 *	Method      : GigeVCam::is_SetMeasurePoint_allowed()
 *	Description : Execution allowed for SetMeasurePoint attribute
 */
//--------------------------------------------------------
bool GigeVCam::is_SetMeasurePoint_allowed(TANGO_UNUSED(const CORBA::Any &any))
{
	//	Compare device state with not allowed states.
	if (get_state()==Tango::OFF ||
		get_state()==Tango::FAULT)
	{
	/*----- PROTECTED REGION ID(GigeVCam::SetMeasurePointStateAllowed) ENABLED START -----*/

	/*----- PROTECTED REGION END -----*/	//	GigeVCam::SetMeasurePointStateAllowed
		return false;
	}
	return true;
}

//--------------------------------------------------------
/**
 *	Method      : GigeVCam::is_ClearMeasurePoints_allowed()
 *	Description : Execution allowed for ClearMeasurePoints attribute
 */
//--------------------------------------------------------
bool GigeVCam::is_ClearMeasurePoints_allowed(TANGO_UNUSED(const CORBA::Any &any))
{
	//	Compare device state with not allowed states.
	if (get_state()==Tango::OFF ||
		get_state()==Tango::FAULT)
	{
	/*----- PROTECTED REGION ID(GigeVCam::ClearMeasurePointsStateAllowed) ENABLED START -----*/

	/*----- PROTECTED REGION END -----*/	//	GigeVCam::ClearMeasurePointsStateAllowed
		return false;
	}
	return true;
}

//--------------------------------------------------------
/**
 *	Method      : GigeVCam::is_GetIntensity_allowed()
 *	Description : Execution allowed for GetIntensity attribute
 */
//--------------------------------------------------------
bool GigeVCam::is_GetIntensity_allowed(TANGO_UNUSED(const CORBA::Any &any))
{
	//	Compare device state with not allowed states.
	if (get_state()==Tango::OFF ||
		get_state()==Tango::FAULT)
	{
	/*----- PROTECTED REGION ID(GigeVCam::GetIntensityStateAllowed) ENABLED START -----*/

	/*----- PROTECTED REGION END -----*/	//	GigeVCam::GetIntensityStateAllowed
		return false;
	}
	return true;
}

//--------------------------------------------------------
/**
 *	Method      : GigeVCam::is_GetHorProfile_allowed()
 *	Description : Execution allowed for GetHorProfile attribute
 */
//--------------------------------------------------------
bool GigeVCam::is_GetHorProfile_allowed(TANGO_UNUSED(const CORBA::Any &any))
{
	//	Compare device state with not allowed states.
	if (get_state()==Tango::OFF ||
		get_state()==Tango::FAULT)
	{
	/*----- PROTECTED REGION ID(GigeVCam::GetHorProfileStateAllowed) ENABLED START -----*/

	/*----- PROTECTED REGION END -----*/	//	GigeVCam::GetHorProfileStateAllowed
		return false;
	}
	return true;
}

//--------------------------------------------------------
/**
 *	Method      : GigeVCam::is_GetVerProfile_allowed()
 *	Description : Execution allowed for GetVerProfile attribute
 */
//--------------------------------------------------------
bool GigeVCam::is_GetVerProfile_allowed(TANGO_UNUSED(const CORBA::Any &any))
{
	//	Compare device state with not allowed states.
	if (get_state()==Tango::OFF ||
		get_state()==Tango::FAULT)
	{
	/*----- PROTECTED REGION ID(GigeVCam::GetVerProfileStateAllowed) ENABLED START -----*/

	/*----- PROTECTED REGION END -----*/	//	GigeVCam::GetVerProfileStateAllowed
		return false;
	}
	return true;
}

//--------------------------------------------------------
/**
 *	Method      : GigeVCam::is_GetHorFitProfile_allowed()
 *	Description : Execution allowed for GetHorFitProfile attribute
 */
//--------------------------------------------------------
bool GigeVCam::is_GetHorFitProfile_allowed(TANGO_UNUSED(const CORBA::Any &any))
{
	//	Compare device state with not allowed states.
	if (get_state()==Tango::OFF ||
		get_state()==Tango::FAULT)
	{
	/*----- PROTECTED REGION ID(GigeVCam::GetHorFitProfileStateAllowed) ENABLED START -----*/

	/*----- PROTECTED REGION END -----*/	//	GigeVCam::GetHorFitProfileStateAllowed
		return false;
	}
	return true;
}

//--------------------------------------------------------
/**
 *	Method      : GigeVCam::is_GetVerFitProfile_allowed()
 *	Description : Execution allowed for GetVerFitProfile attribute
 */
//--------------------------------------------------------
bool GigeVCam::is_GetVerFitProfile_allowed(TANGO_UNUSED(const CORBA::Any &any))
{
	//	Compare device state with not allowed states.
	if (get_state()==Tango::OFF ||
		get_state()==Tango::FAULT)
	{
	/*----- PROTECTED REGION ID(GigeVCam::GetVerFitProfileStateAllowed) ENABLED START -----*/

	/*----- PROTECTED REGION END -----*/	//	GigeVCam::GetVerFitProfileStateAllowed
		return false;
	}
	return true;
}

//--------------------------------------------------------
/**
 *	Method      : GigeVCam::is_SaveParam_allowed()
 *	Description : Execution allowed for SaveParam attribute
 */
//--------------------------------------------------------
bool GigeVCam::is_SaveParam_allowed(TANGO_UNUSED(const CORBA::Any &any))
{
	//	Not any excluded states for SaveParam command.
	/*----- PROTECTED REGION ID(GigeVCam::SaveParamStateAllowed) ENABLED START -----*/

	/*----- PROTECTED REGION END -----*/	//	GigeVCam::SaveParamStateAllowed
	return true;
}

//--------------------------------------------------------
/**
 *	Method      : GigeVCam::is_ClearReference_allowed()
 *	Description : Execution allowed for ClearReference attribute
 */
//--------------------------------------------------------
bool GigeVCam::is_ClearReference_allowed(TANGO_UNUSED(const CORBA::Any &any))
{
	//	Not any excluded states for ClearReference command.
	/*----- PROTECTED REGION ID(GigeVCam::ClearReferenceStateAllowed) ENABLED START -----*/

	/*----- PROTECTED REGION END -----*/	//	GigeVCam::ClearReferenceStateAllowed
	return true;
}

//--------------------------------------------------------
/**
 *	Method      : GigeVCam::is_ExposureAutoOnce_allowed()
 *	Description : Execution allowed for ExposureAutoOnce attribute
 */
//--------------------------------------------------------
bool GigeVCam::is_ExposureAutoOnce_allowed(TANGO_UNUSED(const CORBA::Any &any))
{
	//	Compare device state with not allowed states.
	if (get_state()==Tango::OFF ||
		get_state()==Tango::FAULT)
	{
	/*----- PROTECTED REGION ID(GigeVCam::ExposureAutoOnceStateAllowed) ENABLED START -----*/

	/*----- PROTECTED REGION END -----*/	//	GigeVCam::ExposureAutoOnceStateAllowed
		return false;
	}
	return true;
}

//--------------------------------------------------------
/**
 *	Method      : GigeVCam::is_GainAutoOnce_allowed()
 *	Description : Execution allowed for GainAutoOnce attribute
 */
//--------------------------------------------------------
bool GigeVCam::is_GainAutoOnce_allowed(TANGO_UNUSED(const CORBA::Any &any))
{
	//	Compare device state with not allowed states.
	if (get_state()==Tango::OFF ||
		get_state()==Tango::FAULT)
	{
	/*----- PROTECTED REGION ID(GigeVCam::GainAutoOnceStateAllowed) ENABLED START -----*/

	/*----- PROTECTED REGION END -----*/	//	GigeVCam::GainAutoOnceStateAllowed
		return false;
	}
	return true;
}

//--------------------------------------------------------
/**
 *	Method      : GigeVCam::is_GetFitError_allowed()
 *	Description : Execution allowed for GetFitError attribute
 */
//--------------------------------------------------------
bool GigeVCam::is_GetFitError_allowed(TANGO_UNUSED(const CORBA::Any &any))
{
	//	Not any excluded states for GetFitError command.
	/*----- PROTECTED REGION ID(GigeVCam::GetFitErrorStateAllowed) ENABLED START -----*/

	/*----- PROTECTED REGION END -----*/	//	GigeVCam::GetFitErrorStateAllowed
	return true;
}

//--------------------------------------------------------
/**
 *	Method      : GigeVCam::is_GetBunchNumber_allowed()
 *	Description : Execution allowed for GetBunchNumber attribute
 */
//--------------------------------------------------------
bool GigeVCam::is_GetBunchNumber_allowed(TANGO_UNUSED(const CORBA::Any &any))
{
	//	Not any excluded states for GetBunchNumber command.
	/*----- PROTECTED REGION ID(GigeVCam::GetBunchNumberStateAllowed) ENABLED START -----*/

	/*----- PROTECTED REGION END -----*/	//	GigeVCam::GetBunchNumberStateAllowed
	return true;
}

//--------------------------------------------------------
/**
 *	Method      : GigeVCam::is_GetMaxVal_allowed()
 *	Description : Execution allowed for GetMaxVal attribute
 */
//--------------------------------------------------------
bool GigeVCam::is_GetMaxVal_allowed(TANGO_UNUSED(const CORBA::Any &any))
{
	//	Not any excluded states for GetMaxVal command.
	/*----- PROTECTED REGION ID(GigeVCam::GetMaxValStateAllowed) ENABLED START -----*/

	/*----- PROTECTED REGION END -----*/	//	GigeVCam::GetMaxValStateAllowed
	return true;
}

//--------------------------------------------------------
/**
 *	Method      : GigeVCam::is_GetGain_allowed()
 *	Description : Execution allowed for GetGain attribute
 */
//--------------------------------------------------------
bool GigeVCam::is_GetGain_allowed(TANGO_UNUSED(const CORBA::Any &any))
{
	//	Not any excluded states for GetGain command.
	/*----- PROTECTED REGION ID(GigeVCam::GetGainStateAllowed) ENABLED START -----*/

	/*----- PROTECTED REGION END -----*/	//	GigeVCam::GetGainStateAllowed
	return true;
}

//--------------------------------------------------------
/**
 *	Method      : GigeVCam::is_GetExposure_allowed()
 *	Description : Execution allowed for GetExposure attribute
 */
//--------------------------------------------------------
bool GigeVCam::is_GetExposure_allowed(TANGO_UNUSED(const CORBA::Any &any))
{
	//	Not any excluded states for GetExposure command.
	/*----- PROTECTED REGION ID(GigeVCam::GetExposureStateAllowed) ENABLED START -----*/

	/*----- PROTECTED REGION END -----*/	//	GigeVCam::GetExposureStateAllowed
	return true;
}


/*----- PROTECTED REGION ID(GigeVCam::GigeVCamStateAllowed.AdditionalMethods) ENABLED START -----*/

//	Additional Methods

/*----- PROTECTED REGION END -----*/	//	GigeVCam::GigeVCamStateAllowed.AdditionalMethods

}	//	End of namespace
